/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         __route_parser_parse
#define yylex           __route_parser_lex
#define yyerror         __route_parser_error
#define yydebug         __route_parser_debug
#define yynerrs         __route_parser_nerrs

#define yylval          __route_parser_lval
#define yychar          __route_parser_char

/* Copy the first part of user declarations.  */
#line 1 "./osm_router_parser_y.y" /* yacc.c:339  */

/*
 * Copyright (c) 2023 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 * Copyright (c) 2016, Bay Microsystems, Inc All Rights Reserved
 * Copyright (c) 2016 Mellanox Technologies LTD. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */
/*
 * Abstract:
 *    Grammar of OSM route parser.
 *
 * Environment:
 *    Linux User Mode
 *
 * Author:
 *    Manickavel Subramani, Bay Microsystems
 */

#include <stdio.h>
#include <assert.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_ROUTER_PARSER_Y_Y
#include <opensm/osm_opensm.h>
#include <opensm/osm_router_policy.h>

#define OSM_ROUTE_POLICY_MAX_LINE_LEN         1024*10

typedef struct route_tmp_parser_struct_t_ {
	char       str[OSM_ROUTE_POLICY_MAX_LINE_LEN];
	uint64_t   num_pair[2];
	cl_list_t  str_list;
	cl_list_t  num_list;
	cl_list_t  num_pair_list;
} route_tmp_parser_struct_t;

typedef struct flid_range {
	uint64_t subnet_prefix;
	uint16_t start;
	uint16_t end;
} flid_range_t;

static void __parser_tmp_struct_init();
static void __parser_tmp_struct_reset();
static void __parser_tmp_struct_destroy();

static char * __parser_strip_white(char * str);
static int __parser_str2uint64(uint64_t * p_val, char * str);
static int __validate_uint64bit_string(char *str);

static int __parser_route_rules_end();
static int __parser_route_rule_end();
static void __parser_add_prefix_range_to_prefix_list(
	uint64_t ** range_arr,
	unsigned range_len);

static int __rangelist2rangearr(
	cl_list_t    * p_list,
	uint64_t  ** * p_arr,
	unsigned     * p_arr_len);
static int __validate_route_rule();

static int __parser_load_share_rule_end();
static int __loadguidtomap(cl_list_t * p_list);
static int __validate_load_share_rule();

static int __parser_subn_verify_global_flid_set(flid_range_t range);
static int __parser_subn_verify_local_flid_set(flid_range_t range);
static void __parser_clear_ranges();

static void yyerror(const char *format, ...);
extern FILE * __route_parser_in;
char *__route_parser_yylval = NULL;
int __route_parser_parse();
int __route_parser_lex();

extern int errno;

#define RESET_BUFFER  __parser_tmp_struct_reset()
#define INVALID_GUID (0xFFFFFFFFFFFFFFFFULL)

route_tmp_parser_struct_t route_tmp_parser_struct;

int route_column_num;
int route_line_num;

int sn_count;
int guid_count;
int weight_count;
int default_count;


osm_router_policy_t	* p_router_policy;
osm_route_rule_t	* p_current_route_rule = NULL;
osm_load_share_rule_t	* p_load_share_rule = NULL;
osm_log_t		* p_route_parser_osm_log;

static struct osm_subn_opt *p_opts;
static flid_range_t current_range;
static flid_range_t local_ranges[MAX_ROUTER_SUPPORTED_SUBNETS];
static int local_ranges_count = 0;
static int is_my_subnet = 0;
static int found_my_subnet = 0;
static int flid_first_num = 1;
static int in_global = 1;

/***************************************************/


#line 216 "./osm_router_parser_y.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "osm_router_parser_y.h".  */
#ifndef YY__ROUTE_PARSER_OSM_ROUTER_PARSER_Y_H_INCLUDED
# define YY__ROUTE_PARSER_OSM_ROUTER_PARSER_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int __route_parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TK_NUMBER = 258,
    TK_DASH = 259,
    TK_DOTDOT = 260,
    TK_COMMA = 261,
    TK_ASTERISK = 262,
    TK_TEXT = 263,
    TK_WHITE = 264,
    TK_ROUTE_RULES_START = 265,
    TK_ROUTE_RULES_END = 266,
    TK_ROUTE_RULE_START = 267,
    TK_ROUTE_RULE_END = 268,
    TK_NAME = 269,
    TK_SUBNET_PREFIX = 270,
    TK_ROUTER_GUID = 271,
    TK_ROUTE_WEIGHT = 272,
    TK_LOAD_SHARE_RULES_START = 273,
    TK_LOAD_SHARE_RULES_END = 274,
    TK_LOAD_SHARE_RULE_START = 275,
    TK_LOAD_SHARE_RULE_END = 276,
    TK_LOAD_SHARE_SUBNET_PREFIX = 277,
    TK_LOAD_SHARE_GUID = 278,
    TK_FLID_START = 279,
    TK_FLID_END = 280,
    TK_FLID_GLOBAL = 281,
    TK_FLID_SUBNET_PREFIX = 282
  };
#endif
/* Tokens.  */
#define TK_NUMBER 258
#define TK_DASH 259
#define TK_DOTDOT 260
#define TK_COMMA 261
#define TK_ASTERISK 262
#define TK_TEXT 263
#define TK_WHITE 264
#define TK_ROUTE_RULES_START 265
#define TK_ROUTE_RULES_END 266
#define TK_ROUTE_RULE_START 267
#define TK_ROUTE_RULE_END 268
#define TK_NAME 269
#define TK_SUBNET_PREFIX 270
#define TK_ROUTER_GUID 271
#define TK_ROUTE_WEIGHT 272
#define TK_LOAD_SHARE_RULES_START 273
#define TK_LOAD_SHARE_RULES_END 274
#define TK_LOAD_SHARE_RULE_START 275
#define TK_LOAD_SHARE_RULE_END 276
#define TK_LOAD_SHARE_SUBNET_PREFIX 277
#define TK_LOAD_SHARE_GUID 278
#define TK_FLID_START 279
#define TK_FLID_END 280
#define TK_FLID_GLOBAL 281
#define TK_FLID_SUBNET_PREFIX 282

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE __route_parser_lval;

int __route_parser_parse (void);

#endif /* !YY__ROUTE_PARSER_OSM_ROUTER_PARSER_Y_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 321 "./osm_router_parser_y.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   49

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  28
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  58
/* YYNRULES -- Number of rules.  */
#define YYNRULES  77
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  103

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   282

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   177,   177,   180,   181,   184,   185,   186,   203,   206,
     207,   210,   215,   220,   251,   254,   270,   274,   295,   298,
     303,   309,   310,   313,   316,   331,   337,   338,   341,   342,
     343,   344,   355,   395,   400,   421,   426,   427,   430,   440,
     464,   469,   491,   507,   510,   511,   514,   517,   535,   541,
     542,   545,   546,   554,   575,   580,   589,   594,   597,   603,
     609,   614,   628,   640,   657,   665,   666,   669,   679,   682,
     694,   697,   703,   722,   741,   749,   762,   771
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TK_NUMBER", "TK_DASH", "TK_DOTDOT",
  "TK_COMMA", "TK_ASTERISK", "TK_TEXT", "TK_WHITE", "TK_ROUTE_RULES_START",
  "TK_ROUTE_RULES_END", "TK_ROUTE_RULE_START", "TK_ROUTE_RULE_END",
  "TK_NAME", "TK_SUBNET_PREFIX", "TK_ROUTER_GUID", "TK_ROUTE_WEIGHT",
  "TK_LOAD_SHARE_RULES_START", "TK_LOAD_SHARE_RULES_END",
  "TK_LOAD_SHARE_RULE_START", "TK_LOAD_SHARE_RULE_END",
  "TK_LOAD_SHARE_SUBNET_PREFIX", "TK_LOAD_SHARE_GUID", "TK_FLID_START",
  "TK_FLID_END", "TK_FLID_GLOBAL", "TK_FLID_SUBNET_PREFIX", "$accept",
  "head", "route_policy_entries", "route_policy_entry", "flid_section",
  "flid_locals", "flid_start", "flid_global", "flid_num", "flid_local",
  "flid_subnet_prefix", "flid_dash", "flid_end", "route_rules_section",
  "route_rules_start", "route_rules_end", "route_rules", "route_rule",
  "route_rule_start", "route_rule_end", "route_rule_entries",
  "route_rule_entry", "route_rule_name", "route_rule_name_start",
  "route_rule_subnet_prefix", "route_rule_subnet_prefix_start",
  "asterisk_or_list_of_ranges", "route_rule_asterisk",
  "route_rule_router_guid", "route_rule_router_guid_start",
  "route_rule_weight", "route_rule_weight_start",
  "load_share_rules_section", "load_share_rules", "load_share_rule",
  "load_share_rule_start", "load_share_rule_end",
  "load_share_rule_entries", "load_share_rule_entry",
  "load_share_rule_subnet_prefix", "load_share_rule_subnet_prefix_start",
  "load_share_rule_router_guid", "load_share_rule_router_guid_start",
  "load_share_list", "load_share_list_with_dash",
  "single_number_load_share", "number_load_share_1", "number_load_share_2",
  "single_string", "single_string_elems", "single_string_element",
  "single_number", "number", "list_of_ranges", "num_list_with_dash",
  "single_number_from_range", "number_from_range_1", "number_from_range_2", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282
};
# endif

#define YYPACT_NINF -54

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-54)))

#define YYTABLE_NINF -77

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -54,    25,    -9,   -54,   -54,     6,   -54,   -54,   -54,     1,
     -54,    16,   -54,   -54,    -7,   -54,   -54,    26,   -54,   -54,
      -5,   -54,   -54,   -54,   -54,   -13,   -54,    27,    -4,   -54,
     -54,   -54,     3,   -54,   -54,   -54,   -54,   -54,   -54,    29,
     -54,     2,   -54,    26,   -54,   -54,   -54,    26,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,    22,   -54,     7,
     -54,    29,   -54,    29,   -54,   -54,   -54,    30,   -54,   -54,
     -54,   -54,    31,   -54,    27,   -54,   -54,    22,   -54,    32,
     -54,   -54,   -54,   -54,    33,   -54,    34,   -54,   -54,    37,
      26,   -54,    38,    39,   -54,   -54,   -54,   -54,    40,   -54,
     -54,    39,   -54
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     2,     1,    19,     0,    11,     4,     7,     0,
       5,     0,     6,    47,     0,    44,    49,     0,     9,    24,
       0,    21,    26,    43,    45,     0,    13,     0,     0,    20,
      18,    22,     0,    54,    56,    48,    46,    50,    51,     0,
      52,     0,    16,     0,    17,    15,    10,     0,     8,    25,
      33,    35,    40,    42,    23,    27,    28,     0,    29,     0,
      30,     0,    31,     0,    69,    53,    68,    61,    60,    55,
      57,    58,     0,    12,     0,    67,    32,    64,    65,    75,
      38,    34,    36,    37,    70,    71,     0,    39,    41,     0,
       0,    66,     0,     0,    63,    59,    14,    74,     0,    77,
      72,     0,    73
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -43,   -54,
     -54,   -41,   -54,   -54,   -54,   -54,   -54,    17,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,    35,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -34,   -39,   -54,   -54,   -54,   -47,   -46,   -53
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,     7,     8,    28,     9,    18,    27,    46,
      47,    43,    48,    10,    11,    30,    20,    21,    22,    54,
      32,    55,    56,    57,    58,    59,    81,    82,    60,    61,
      62,    63,    12,    14,    15,    16,    36,    25,    37,    38,
      39,    40,    41,    69,    70,    71,    72,    95,    76,    77,
      78,    65,    66,    83,    84,    85,    86,   100
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      73,     4,    33,    34,    74,    67,    29,    19,    35,     5,
      79,    68,    23,    13,    80,     6,    49,    50,    51,    52,
      53,    44,    87,    45,    88,     3,    13,    17,    19,    26,
      75,    42,    64,    90,   -62,    89,   -76,    31,    93,    92,
      94,    79,    99,    91,   101,    97,    98,    96,   102,    24
};

static const yytype_uint8 yycheck[] =
{
      43,    10,    15,    16,    47,     3,    11,    12,    21,    18,
       3,     9,    19,    20,     7,    24,    13,    14,    15,    16,
      17,    25,    61,    27,    63,     0,    20,    26,    12,     3,
       8,     4,     3,    74,     4,     4,     4,    20,     4,     6,
       3,     3,     3,    77,     4,    92,    92,    90,   101,    14
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    29,    30,     0,    10,    18,    24,    31,    32,    34,
      41,    42,    60,    20,    61,    62,    63,    26,    35,    12,
      44,    45,    46,    19,    62,    65,     3,    36,    33,    11,
      43,    45,    48,    15,    16,    21,    64,    66,    67,    68,
      69,    70,     4,    39,    25,    27,    37,    38,    40,    13,
      14,    15,    16,    17,    47,    49,    50,    51,    52,    53,
      56,    57,    58,    59,     3,    79,    80,     3,     9,    71,
      72,    73,    74,    36,    36,     8,    76,    77,    78,     3,
       7,    54,    55,    81,    82,    83,    84,    79,    79,     4,
      39,    78,     6,     4,     3,    75,    36,    83,    84,     3,
      85,     4,    85
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    28,    29,    30,    30,    31,    31,    31,    32,    33,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    44,    45,    46,    47,    48,    48,    49,    49,
      49,    49,    50,    51,    52,    53,    54,    54,    55,    56,
      57,    58,    59,    60,    61,    61,    62,    63,    64,    65,
      65,    66,    66,    67,    68,    69,    70,    71,    72,    72,
      72,    73,    74,    75,    76,    77,    77,    78,    79,    80,
      81,    82,    82,    82,    82,    83,    84,    85
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     4,     0,
       2,     1,     4,     1,     4,     1,     1,     1,     3,     1,
       1,     1,     2,     3,     1,     1,     0,     2,     1,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     2,
       1,     2,     1,     3,     1,     2,     3,     1,     1,     0,
       2,     1,     1,     2,     1,     2,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     3,     5,     3,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 11:
#line 210 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
	is_my_subnet = 0;
}
#line 1488 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 12:
#line 215 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
	in_global = 1;
	flid_first_num = 1;
	}
#line 1497 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 13:
#line 220 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
	if (flid_first_num) {
		current_range.start = (uint16_t)strtoull(__route_parser_yylval, NULL, 10);
		free(__route_parser_yylval);
	}
	else {
		current_range.end = (uint16_t)strtoull(__route_parser_yylval, NULL, 10);
		free(__route_parser_yylval);

		if (in_global) {
			if (__parser_subn_verify_global_flid_set(current_range))
				return 1;

			p_opts->global_flid_start = current_range.start;
			p_opts->global_flid_end = current_range.end;
		}
		else {
			if (__parser_subn_verify_local_flid_set(current_range)) {
				return 1;
			}
			if (is_my_subnet) {
				p_opts->local_flid_start = current_range.start;
				p_opts->local_flid_end = current_range.end;
			}
			local_ranges[local_ranges_count++] = current_range;
		}
	}

}
#line 1531 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 15:
#line 254 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
	flid_first_num = 1;
	in_global = 0;

	if (local_ranges_count >= MAX_ROUTER_SUPPORTED_SUBNETS) {
		yyerror("Too many local flid ranges entered.");
		return 1;
	}

	uint64_t subnet_prefix = (uint64_t)strtoull(__route_parser_yylval, NULL, 0);
	free(__route_parser_yylval);
	is_my_subnet = (p_opts->subnet_prefix == cl_hton64(subnet_prefix));
	found_my_subnet |= is_my_subnet;
	current_range.subnet_prefix = subnet_prefix;
}
#line 1551 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 16:
#line 270 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
	flid_first_num = 0;
}
#line 1559 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 17:
#line 274 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
	if (!found_my_subnet) {
		yyerror("Current subnet prefix not accounted for in policy file");
		return 1;
	}
}
#line 1570 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 19:
#line 298 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				default_count = 0;
			}
#line 1578 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 20:
#line 303 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
			if( __parser_route_rules_end() )
					return 1;
			}
#line 1587 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 24:
#line 316 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
			if (p_current_route_rule) {
				OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
					"ERR 9F00: Current rule already exist "
					"on rule start\n");
					return 1;
			}
			p_current_route_rule =
			(osm_route_rule_t *) calloc(1, sizeof(osm_route_rule_t));
			sn_count = 0;
			guid_count = 0;
			weight_count = 0;
		}
#line 1605 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 25:
#line 331 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
			if ( __parser_route_rule_end() )
				return 1;
		}
#line 1614 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 32:
#line 355 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
			/* 'name' of 'route-rule' - one instance */
			cl_list_iterator_t    list_iterator;
			char	* tmp_str;

			/*
			 * If p_current_route_rule is NULL, or already has a name,
			 * drops currently parsed name.
			 */
			if (!p_current_route_rule || p_current_route_rule->name) {
				if (p_current_route_rule)
					yyerror("route-rule has multiple 'name' tags");

				list_iterator =
					cl_list_head(&route_tmp_parser_struct.str_list);
				if ( list_iterator !=
					cl_list_end(&route_tmp_parser_struct.str_list) ) {
					tmp_str = (char*)cl_list_obj(list_iterator);
					if (tmp_str)
						free(tmp_str);
				}
				cl_list_remove_all(&route_tmp_parser_struct.str_list);
				return 1;
			}

			list_iterator =
				cl_list_head(&route_tmp_parser_struct.str_list);
			if ( list_iterator !=
				cl_list_end(&route_tmp_parser_struct.str_list) ) {
				tmp_str = (char*)cl_list_obj(list_iterator);
				if (tmp_str)
					p_current_route_rule->name = tmp_str;
				OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
					"policy Name:(%s)\n",
					p_current_route_rule->name);
			}
			cl_list_remove_all(&route_tmp_parser_struct.str_list);
		}
#line 1657 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 33:
#line 395 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				RESET_BUFFER;
			}
#line 1665 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 34:
#line 400 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
			/* 'route-guid' in 'route-rule' - any num of instances */
			/* list of guid ranges */
			sn_count++;
			if (cl_list_count(&route_tmp_parser_struct.num_pair_list))
			{
				uint64_t ** range_arr;
				unsigned range_len;

				if(!__rangelist2rangearr(
					&route_tmp_parser_struct.num_pair_list,
					&range_arr, &range_len )) {
					return -1;
				}

				__parser_add_prefix_range_to_prefix_list(
							range_arr, range_len);
			}
		}
#line 1689 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 35:
#line 421 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
					RESET_BUFFER;
				}
#line 1697 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 38:
#line 430 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				uint64_t * num_pair =
					(uint64_t*)malloc(sizeof(uint64_t)*2);
				num_pair[0] = 0x0;
				num_pair[1] = 0x0;
				cl_list_insert_tail(
					&route_tmp_parser_struct.num_pair_list,
					num_pair);
			}
#line 1711 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 39:
#line 440 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				/* 'route-guid' in 'route-rule' -
				 * any num of instances
				 */
				cl_list_iterator_t    list_iterator;
				uint64_t	* p_tmp_num;

				guid_count++;

				list_iterator = cl_list_head(&route_tmp_parser_struct.num_list);
				p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
				if (p_tmp_num && p_current_route_rule) {
					p_current_route_rule->router_guid =
						cl_hton64((uint64_t)(*p_tmp_num));
					OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
						"GUID  0x%016" PRIx64 "\n",
						cl_ntoh64(p_current_route_rule->router_guid));
					free(p_tmp_num);
				}

				cl_list_remove_all(&route_tmp_parser_struct.num_list);
			}
#line 1738 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 40:
#line 464 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
					RESET_BUFFER;
				}
#line 1746 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 41:
#line 469 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
			/* 'weight' in 'route-rule' -
			 * one instance of one number
			 */
			cl_list_iterator_t    list_iterator;
			uint64_t	* p_tmp_num;

			weight_count++;
			list_iterator = cl_list_head(&route_tmp_parser_struct.num_list);
			p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
			if (p_tmp_num && p_current_route_rule) {
				p_current_route_rule->weight =
					(uint32_t)(*p_tmp_num);
				OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
					"Weight:%d\n",
					p_current_route_rule->weight);
				free(p_tmp_num);
			}
			cl_list_remove_all(&route_tmp_parser_struct.num_list);
			}
#line 1771 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 42:
#line 491 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
					RESET_BUFFER;
				}
#line 1779 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 47:
#line 517 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				if (p_load_share_rule) {
					OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
						"ERR 9F01: Current load share rule already exist "
						"on rule start\n");
					return 1;
				}

				p_load_share_rule =
						(osm_load_share_rule_t *) calloc(1,
							sizeof(osm_load_share_rule_t));

				cl_map_init(&p_load_share_rule->load_share_map, 16);
				sn_count = 0;
				guid_count = 0;
			}
#line 1800 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 48:
#line 535 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				if ( __parser_load_share_rule_end() )
					return 1;
			}
#line 1809 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 53:
#line 554 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				/* 'subnet-prefix' in 'load-share-rule' - any num of instances */
				sn_count++;
				cl_list_iterator_t list_iterator;
				uint64_t * p_tmp_num;

				list_iterator = cl_list_head(&route_tmp_parser_struct.num_list);
				p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
				if (p_tmp_num) {
					p_load_share_rule->subnet_prefix = cl_hton64((uint64_t)(*p_tmp_num));

					OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
						"PREFIX  0x%016" PRIx64 "\n",
						cl_ntoh64(p_load_share_rule->subnet_prefix));
					free(p_tmp_num);
				}

				cl_list_remove_all(&route_tmp_parser_struct.num_list);
			}
#line 1833 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 54:
#line 575 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
						RESET_BUFFER;
					}
#line 1841 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 55:
#line 580 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				/* 'route-guid' in 'load-share-rule' - any num of instances */
				guid_count++;
				if (cl_list_count(&route_tmp_parser_struct.num_pair_list))
					if(__loadguidtomap(&route_tmp_parser_struct.num_pair_list) < 0)
						return -1;
				}
#line 1853 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 56:
#line 589 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
						RESET_BUFFER;
					}
#line 1861 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 58:
#line 597 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
					uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
					num_pair[0] = route_tmp_parser_struct.num_pair[0];
					num_pair[1] = route_tmp_parser_struct.num_pair[1];
					cl_list_insert_tail(&route_tmp_parser_struct.num_pair_list, num_pair);
				}
#line 1872 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 59:
#line 603 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
					uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
					num_pair[0] = route_tmp_parser_struct.num_pair[0];
					num_pair[1] = route_tmp_parser_struct.num_pair[1];
					cl_list_insert_tail(&route_tmp_parser_struct.num_pair_list, num_pair);
				}
#line 1883 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 60:
#line 609 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
					yyerror("GUID-Percent syntex error");
				}
#line 1891 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 61:
#line 614 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
					if(__parser_str2uint64(&route_tmp_parser_struct.num_pair[0],
						__route_parser_yylval))
						return -1;

					route_tmp_parser_struct.num_pair[1] = 50;

					OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
						"GUID  0x%016" PRIx64 "\n",
						cl_ntoh64(route_tmp_parser_struct.num_pair[0]));
					free(__route_parser_yylval);
				}
#line 1908 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 62:
#line 628 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				if(__parser_str2uint64(&route_tmp_parser_struct.num_pair[0],
					__route_parser_yylval))
					return -1;

				OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
					"GUID 0x%016" PRIx64 "\n",
					cl_ntoh64(route_tmp_parser_struct.num_pair[0]));
				free(__route_parser_yylval);
			}
#line 1923 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 63:
#line 640 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				if(__parser_str2uint64(&route_tmp_parser_struct.num_pair[1],
					__route_parser_yylval))
					return -1;

				OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
					"Percentage :%d\n",
					(uint32_t )route_tmp_parser_struct.num_pair[1]);
				free(__route_parser_yylval);
			}
#line 1938 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 64:
#line 657 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
			cl_list_insert_tail(&route_tmp_parser_struct.str_list,
				strdup(__parser_strip_white(
						route_tmp_parser_struct.str)));
			route_tmp_parser_struct.str[0] = '\0';
		}
#line 1949 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 67:
#line 669 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				int len = strlen(__route_parser_yylval);
				if(len > 1024)
					yyerror("String length is grater then 1024");
				strcat(route_tmp_parser_struct.str,
					__route_parser_yylval);
				free(__route_parser_yylval);
			}
#line 1962 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 69:
#line 682 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
		uint64_t * p_num = (uint64_t*)malloc(sizeof(uint64_t));
		if(__parser_str2uint64(p_num,__route_parser_yylval)) {
			free(p_num);
			return -1;
		}

		free(__route_parser_yylval);
		cl_list_insert_tail(&route_tmp_parser_struct.num_list, p_num);
	}
#line 1977 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 71:
#line 697 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
				num_pair[0] = route_tmp_parser_struct.num_pair[0];
				num_pair[1] = route_tmp_parser_struct.num_pair[1];
				cl_list_insert_tail(&route_tmp_parser_struct.num_pair_list, num_pair);
			}
#line 1988 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 72:
#line 703 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
				if (route_tmp_parser_struct.num_pair[0] < route_tmp_parser_struct.num_pair[1]) {
					num_pair[0] = route_tmp_parser_struct.num_pair[0];
					num_pair[1] = route_tmp_parser_struct.num_pair[1];
				}
				else {
					OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
						"ERR 9F18:"
						" Invalid Subnet Prefix Range"
						" Min: 0x%016" PRIx64 ""
						" Max: 0x%016" PRIx64 "\n",
						route_tmp_parser_struct.num_pair[0],
						route_tmp_parser_struct.num_pair[1]);
					free(num_pair);
					return -1;
				}
				cl_list_insert_tail(&route_tmp_parser_struct.num_pair_list, num_pair);
			}
#line 2012 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 73:
#line 722 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
				if (route_tmp_parser_struct.num_pair[0] < route_tmp_parser_struct.num_pair[1]) {
					num_pair[0] = route_tmp_parser_struct.num_pair[0];
					num_pair[1] = route_tmp_parser_struct.num_pair[1];
				}
				else {
					OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
						"ERR 9F19:"
						" Invalid Subnet Prefix Range"
						" Min: 0x%016" PRIx64 ""
						" Max: 0x%016" PRIx64 "\n",
						route_tmp_parser_struct.num_pair[0],
						route_tmp_parser_struct.num_pair[1]);
					free(num_pair);
					return -1;
				}
				cl_list_insert_tail(&route_tmp_parser_struct.num_pair_list, num_pair);
			}
#line 2036 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 74:
#line 741 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
				num_pair[0] = route_tmp_parser_struct.num_pair[0];
				num_pair[1] = route_tmp_parser_struct.num_pair[1];
				cl_list_insert_tail(&route_tmp_parser_struct.num_pair_list, num_pair);
			}
#line 2047 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 75:
#line 749 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
					if(__parser_str2uint64(&route_tmp_parser_struct.num_pair[0],
						__route_parser_yylval))
						return -1;

					if(__parser_str2uint64(&route_tmp_parser_struct.num_pair[1],
						__route_parser_yylval))
						return -1;

					free(__route_parser_yylval);
				}
#line 2063 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 76:
#line 762 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				if(__parser_str2uint64(&route_tmp_parser_struct.num_pair[0],
					__route_parser_yylval))
						return -1;

				free(__route_parser_yylval);
			}
#line 2075 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;

  case 77:
#line 771 "./osm_router_parser_y.y" /* yacc.c:1646  */
    {
				if(__parser_str2uint64(&route_tmp_parser_struct.num_pair[1],
					__route_parser_yylval))
					return -1;
				free(__route_parser_yylval);
			}
#line 2086 "./osm_router_parser_y.c" /* yacc.c:1646  */
    break;


#line 2090 "./osm_router_parser_y.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 779 "./osm_router_parser_y.y" /* yacc.c:1906  */


/***************************************************
 ***************************************************/

void osm_route_parse_policy_file(IN osm_subn_t * p_subn)
{
	int res = 0;
	p_route_parser_osm_log = &p_subn->p_osm->log;
	p_opts = &p_subn->opt;

	OSM_LOG_ENTER(p_route_parser_osm_log);

	__route_parser_in = fopen (p_subn->opt.router_policy_file, "r");
	if (!__route_parser_in) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F02: "
			"fopen(%s) failed: %s",
			p_subn->opt.router_policy_file, strerror(errno));
		goto Exit;
	}

	route_column_num = 1;
	route_line_num = 1;
	p_router_policy = &p_subn->p_osm->sm.router_policy_mgr;
	__parser_tmp_struct_init();

	res = __route_parser_parse();

	__parser_tmp_struct_destroy();

	if (res != 0) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F03: "
			"Failed parsing Route policy file (%s)\n",
			p_subn->opt.router_policy_file);
		__parser_clear_ranges();
		p_subn->opt.router_policy_file = NULL;
		goto Exit;
	}

Exit:
	if (__route_parser_in)
		fclose(__route_parser_in);

	OSM_LOG_EXIT(p_route_parser_osm_log);
}

/***************************************************
 ***************************************************/

static void yyerror(const char *format, ...)
{
	char s[256];
	va_list pvar;

	OSM_LOG_ENTER(p_route_parser_osm_log);

	va_start(pvar, format);
	vsnprintf(s, sizeof(s), format, pvar);
	va_end(pvar);

	OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F04: "
		"Syntax error (line %d:%d): %s\n",
		route_line_num, route_column_num, s);
	OSM_LOG_EXIT(p_route_parser_osm_log);
}

/***************************************************
 ***************************************************/

static void __parser_clear_ranges()
{
	p_opts->local_flid_start = 0;
	p_opts->local_flid_end = 0;
	p_opts->global_flid_start = 0;
	p_opts->global_flid_end = 0;
	yyerror("Setting FLID global and local ranges to 0");
}

/***************************************************
 ***************************************************/

static int __parser_subn_verify_global_flid_set(flid_range_t range)
{
	uint8_t lmc_num_lids = (uint8_t) (1 << p_opts->lmc);
	uint16_t sm_min_lid, sm_max_lid, global_start = range.start, global_end = range.end;
	/* values should not be 0 and range should not be empty */
	if (!(global_start && global_end) || global_start >= global_end) {
		yyerror("Invalid Cached Option Values for the router lid ranges: "
			"global_router_lid_start = %u, global_router_lid_end = %u. "
			"Invalid range.", global_start, global_end);
		return 1;
	}

	/* check that the lids are in the unicast LID range */
	if (global_start < IB_LID_UCAST_START_HO || global_start > IB_LID_UCAST_END_HO ||
		 global_end < IB_LID_UCAST_START_HO || global_end > IB_LID_UCAST_END_HO) {
			yyerror("Invalid Cached Option Values for the router lid ranges: "
			"global_router_lid_start = %u, global_router_lid_end = %u. "
			"Values are not in the unicast range [0x%x-0x%x].",
			global_start, global_end, IB_LID_UCAST_START_HO, IB_LID_UCAST_END_HO);
		return 1;
	}

	/* the global range is greater than allowed number of total FLIDs */
	if ((global_start + OSM_MAX_NUMBER_GLOBAL_FLIDS - 1) < global_end) {
		yyerror("Invalid Cached Option Values for the router lid ranges: "
			"global_router_lid_start = %u, global_router_lid_end = %u. "
			"Total number is greater than %u.",
			global_start, global_end, OSM_MAX_NUMBER_GLOBAL_FLIDS);
		return 1;
	}

	/* the total number of global lids is not properly aligned */
	if ((global_end - global_start + 1) % OSM_ROUTER_FLID_ALIGNMENT) {
		yyerror("Invalid Cached Option Values for the router lid ranges: "
			"global_router_lid_start = %u, global_router_lid_end = %u. "
			" The total number of global range is not %u aligned.",
			global_start, global_end, OSM_ROUTER_FLID_ALIGNMENT);
		return 1;
	}

	if ((global_start % OSM_ROUTER_FLID_ALIGNMENT) != 0) {
		yyerror("Invalid Cached Option Values for the router lid ranges: "
			"global_router_lid_start = %u is not %u aligned.",
			global_start, OSM_ROUTER_FLID_ALIGNMENT);
		return 1;
	}

	/* check that the master_sm_lid doesn't conflict the global router lid range */
	if (p_opts->master_sm_lid) {
		sm_min_lid = p_opts->master_sm_lid;
		sm_max_lid = sm_min_lid + lmc_num_lids - 1;
	} else {
		sm_min_lid = sm_max_lid = 0;
	}

	if ((sm_min_lid <= global_start && global_start <= sm_max_lid) ||
	    (global_start <= sm_min_lid && sm_min_lid <= global_end)) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
			"Master_sm_lid %u with number of lids %u "
			"conflicts with global router lid range [%u-%u]. "
			"Setting master_sm_lid to 0.",
			sm_min_lid, lmc_num_lids, global_start, global_end);
		p_opts->master_sm_lid = 0;
	}

	return 0;
}

/***************************************************
 ***************************************************/

static int __parser_subn_verify_local_flid_set(flid_range_t range)
{
	int i;
	uint16_t local_start = range.start, local_end = range.end;

	/* local range of 0 - 0 signifies subnet not participating in FLIDs */
	if (local_start == 0 && local_end == 0)
		return 0;

	/* The range should not be empty */
	if (local_start > local_end) {
		yyerror("Invalid Cached Option Values for the router lid ranges: "
			"local_router_lid_start = %u, local_router_lid_end = %u. "
			"Invalid FLID range.", local_start, local_end);
		return 1;
	}

	/* local should be inside global */
	if (!(local_start >= p_opts->global_flid_start && local_end <= p_opts->global_flid_end)) {
		yyerror("Invalid Cached Option Values for the router lid ranges: "
			"global_router_lid_start = %u, global_router_lid_end = %u, "
			"local_router_lid_start = %u, local_router_lid_end = %u. "
			" The local range is not inside global.",
			p_opts->global_flid_start, p_opts->global_flid_end, local_start, local_end);
		return 1;
	}

	/* local range should not overlap with any other local ranges */
	for (i = 0; i < local_ranges_count; i++) {
		if (local_ranges[i].subnet_prefix == range.subnet_prefix) {
			yyerror("Subnet Prefix 0x%016"PRIx64" is a duplicate!\n", range.subnet_prefix);
			return 1;
		}
		if (!(local_ranges[i].end < local_start || local_end < local_ranges[i].start)) {
			yyerror("Invalid values for the router lid ranges: Local lid overlap: "
				"local lid [%d] start = %u, local lid [%d] end = %u, "
				"local lid [%d] start = %u, local lid [%d] end = %u.",
				local_ranges_count, local_start, local_ranges_count, local_end,
				i, local_ranges[i].start, i, local_ranges[i].end);
			return 1;
		}
	}

	return 0;
}

/***************************************************
 ***************************************************/


static char * __parser_strip_white(char * str)
{
	char *p;

	while (isspace(*str))
		str++;
	if (!*str)
		return str;
	p = str + strlen(str) - 1;
	while (isspace(*p))
		*p-- = '\0';

	return str;
}

int __route_parser_wrap()
{
	return 1;
}

/***************************************************
 ***************************************************/

static int __parser_str2uint64(uint64_t * p_val, char * str)
{
	if(__validate_uint64bit_string(str)){
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F1A "
			"Syntax error (line %d:%d): String: %s \n",
			route_line_num, route_column_num, str);
		free(str);
		return -1;
	}

	*p_val = strtoull(str, NULL, 0);
	return 0;
}

/***************************************************
 ***************************************************/
static int __parser_route_rule_end()
{
	if(__validate_route_rule()) {
		if(p_current_route_rule){
			if (p_current_route_rule->name)
				free(p_current_route_rule->name);

			if(sn_count){
				uint64_t *prefix;
				cl_list_iterator_t list_iterator;
				for (list_iterator =
					cl_list_head(&p_current_route_rule->prefix_list);
					list_iterator !=
					cl_list_end(&p_current_route_rule->prefix_list);
					list_iterator = cl_list_next(list_iterator)){
					prefix = (uint64_t *) cl_list_obj(list_iterator);
					if(prefix)
						free(prefix);
				}
				cl_list_remove_all(&p_current_route_rule->prefix_list);
				cl_list_destroy(&p_current_route_rule->prefix_list);
			}
			free(p_current_route_rule);
			p_current_route_rule = NULL;
		}
		return -1;
	}

	cl_list_insert_tail(&p_router_policy->route_rules, p_current_route_rule);
	p_current_route_rule = NULL;
	return 0;
}

static int __parser_route_rules_end()
{
	cl_list_iterator_t list_iterator;
	cl_list_iterator_t t_list_iterator;
	osm_route_rule_t *p_route_rule = NULL;
	osm_load_share_rule_t *p_load_share_rule = NULL;

	if(default_count > 1) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F1C "
			"Error More than One default route rule in a policy\n");

		/* Destroy route rules */
		list_iterator = cl_list_head(&p_router_policy->route_rules);
		while (list_iterator != cl_list_end(&p_router_policy->route_rules)) {
			p_route_rule = (osm_route_rule_t *) cl_list_obj(list_iterator);
			if (p_route_rule){
				osm_router_policy_route_rule_destroy(p_route_rule);
				t_list_iterator = cl_list_next(list_iterator);
				cl_list_remove_item(
						&p_router_policy->route_rules,
						list_iterator);
				list_iterator = t_list_iterator;
			}
			else
				list_iterator = cl_list_next(list_iterator);
		}

		/* Destroy load share rules */
		list_iterator = cl_list_head(&p_router_policy->load_share_rules);
		while (list_iterator !=
				cl_list_end(&p_router_policy->load_share_rules)) {
			p_load_share_rule = (osm_load_share_rule_t *)
						cl_list_obj(list_iterator);
			if (p_load_share_rule){
				osm_router_policy_load_share_rule_destroy(
								p_load_share_rule);
				t_list_iterator = cl_list_next(list_iterator);
				cl_list_remove_item(
						&p_router_policy->load_share_rules,
						list_iterator);
				list_iterator = t_list_iterator;
			}
			else
				list_iterator = cl_list_next(list_iterator);
		}
		return -1;
	}
	return 0;
}

/***************************************************
 ***************************************************/
static int __parser_load_share_rule_end()
{
	cl_map_iterator_t map_it;

	if(__validate_load_share_rule()) {
		if(p_load_share_rule) {
			for (map_it = cl_map_head(&p_load_share_rule->load_share_map);
				map_it != cl_map_end(&p_load_share_rule->load_share_map);
				map_it = cl_map_next(map_it)) {
				free((void*)cl_map_obj(map_it));
			}
		cl_map_remove_all(&p_load_share_rule->load_share_map);
			cl_map_destroy(&p_load_share_rule->load_share_map);
		}
		return -1;
	}

	for (map_it = cl_map_head(&p_load_share_rule->load_share_map);
		map_it != cl_map_end(&p_load_share_rule->load_share_map);
		map_it = cl_map_next(map_it)) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
			"GUID 0x%016" PRIx64" - %d\n",
			cl_ntoh64(cl_map_key(map_it)),
			*((uint32_t*)cl_map_obj(map_it)));
	}

	cl_list_insert_tail(&p_router_policy->load_share_rules, p_load_share_rule);
	p_load_share_rule = NULL;
	return 0;
}

/***************************************************
 ***************************************************/

static void __parser_tmp_struct_init()
{
	route_tmp_parser_struct.str[0] = '\0';
	cl_list_construct(&route_tmp_parser_struct.str_list);
	cl_list_init(&route_tmp_parser_struct.str_list, 10);
	cl_list_construct(&route_tmp_parser_struct.num_list);
	cl_list_init(&route_tmp_parser_struct.num_list, 10);
	cl_list_construct(&route_tmp_parser_struct.num_pair_list);
	cl_list_init(&route_tmp_parser_struct.num_pair_list, 10);
}

/***************************************************
 ***************************************************/

/*
 * Do NOT free objects from the temp struct.
 * Either they are inserted into the parse tree data
 * structure, or they are already freed when copying
 * their values to the parse tree data structure.
 */
static void __parser_tmp_struct_reset()
{
	route_tmp_parser_struct.str[0] = '\0';
	cl_list_remove_all(&route_tmp_parser_struct.str_list);
	cl_list_remove_all(&route_tmp_parser_struct.num_list);
	cl_list_remove_all(&route_tmp_parser_struct.num_pair_list);
}

/***************************************************
 ***************************************************/

static void __parser_tmp_struct_destroy()
{
	__parser_tmp_struct_reset();
	cl_list_destroy(&route_tmp_parser_struct.str_list);
	cl_list_destroy(&route_tmp_parser_struct.num_list);
	cl_list_destroy(&route_tmp_parser_struct.num_pair_list);
}

/***************************************************
 ***************************************************/

static int __cmp_num_range(const void * p1, const void * p2)
{
	uint64_t * pair1 = *((uint64_t **)p1);
	uint64_t * pair2 = *((uint64_t **)p2);

	if (pair1[0] < pair2[0])
		return -1;
	if (pair1[0] > pair2[0])
		return 1;

	if (pair1[1] < pair2[1])
		return -1;
	if (pair1[1] > pair2[1])
		return 1;

	return 0;
}

/***************************************************
 ***************************************************/

static void __sort_reduce_rangearr(
	uint64_t  **   arr,
	unsigned       arr_len,
	uint64_t  ** * p_res_arr,
	unsigned     * p_res_arr_len )
{
	unsigned i = 0;
	unsigned j = 0;
	unsigned last_valid_ind = 0;
	unsigned valid_cnt = 0;
	uint64_t ** res_arr;
	boolean_t * is_valid_arr;

	*p_res_arr = NULL;
	*p_res_arr_len = 0;

	qsort(arr, arr_len, sizeof(uint64_t*), __cmp_num_range);

	is_valid_arr = (boolean_t *)malloc(arr_len * sizeof(boolean_t));
	is_valid_arr[last_valid_ind] = TRUE;
	valid_cnt++;
	for (i = 1; i < arr_len; i++)
	{
		if (arr[i][0] <= arr[last_valid_ind][1])
		{
			if (arr[i][1] > arr[last_valid_ind][1])
				arr[last_valid_ind][1] = arr[i][1];
			free(arr[i]);
			arr[i] = NULL;
			is_valid_arr[i] = FALSE;
		}
		else if ((arr[i][0] - 1) == arr[last_valid_ind][1])
		{
			arr[last_valid_ind][1] = arr[i][1];
			free(arr[i]);
			arr[i] = NULL;
			is_valid_arr[i] = FALSE;
		}
		else
		{
			is_valid_arr[i] = TRUE;
			last_valid_ind = i;
			valid_cnt++;
		}
	}

	res_arr = (uint64_t **)malloc(valid_cnt * sizeof(uint64_t *));
	for (i = 0; i < arr_len; i++)
	{
		if (is_valid_arr[i]){
			res_arr[j++] = arr[i];
		}
	}
	free(is_valid_arr);
	free(arr);

	*p_res_arr = res_arr;
	*p_res_arr_len = valid_cnt;
}

/***************************************************
 ***************************************************/
static int __validate_subnet_prefix_range(
			uint64_t  **   arr,
			unsigned       arr_len)
{
	int i;
	for (i = 0; i < arr_len; i++)
	{
		if ((arr[i][1] - arr[i][0]) >= 4096) {
			OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
				"ERR 9F17: "
				"Subnet Prefix range is more than"
				" allowed (4096) Configured range :0x%016" PRIx64""
				" Low prefix: 0x%016" PRIx64""
				" High Prefix:0x%016" PRIx64"\n",
				(arr[i][1] - arr[i][0]), arr[i][0], arr[i][1]);
				return 0;
		}
	}
	return 1;
}

/***************************************************
 ***************************************************/

static int __rangelist2rangearr(
	cl_list_t    * p_list,
	uint64_t  ** * p_arr,
	unsigned     * p_arr_len)
{
	cl_list_iterator_t list_iterator;
	unsigned len = cl_list_count(p_list);
	unsigned i = 0;
	uint64_t ** tmp_arr;
	uint64_t ** res_arr = NULL;
	unsigned res_arr_len = 0;

	tmp_arr = (uint64_t **)malloc(len * sizeof(uint64_t *));

	list_iterator = cl_list_head(p_list);
	while( list_iterator != cl_list_end(p_list) )
	{
		tmp_arr[i++] = (uint64_t *)cl_list_obj(list_iterator);
		list_iterator = cl_list_next(list_iterator);
	}
	cl_list_remove_all(p_list);

	if(!__validate_subnet_prefix_range(tmp_arr,len)) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F14: "
			"Invalid subnet-prefix range \n");
		free(tmp_arr);
		return 0;
	}
	__sort_reduce_rangearr( tmp_arr, len, &res_arr,
				&res_arr_len );
	*p_arr = res_arr;
	*p_arr_len = res_arr_len;
	return 1;
}

/***************************************************
 ***************************************************/

static void __parser_add_prefix_range_to_prefix_list(
	uint64_t  ** range_arr,
	unsigned     range_len)
{
	unsigned i;
	uint64_t *prefix;
	uint64_t prefix_ho;
	cl_qlist_t *ql = &(&p_current_route_rule->prefix_list)->list;

	if (!range_arr || !range_len)
		return;

	if(!p_current_route_rule){
		for (i = 0; i < range_len; i++)
			free(range_arr[i]);
		free(range_arr);
		return;
	}

	if(ql->state != CL_INITIALIZED){
		cl_list_construct(&p_current_route_rule->prefix_list);
		cl_list_init(&p_current_route_rule->prefix_list, 32);
	}

	for (i = 0; i < range_len; i++) {
		for (prefix_ho = range_arr[i][0];
			prefix_ho <= range_arr[i][1]; prefix_ho++) {
			prefix = (uint64_t*)malloc(sizeof(uint64_t));
			*prefix = cl_hton64(prefix_ho);
			cl_list_insert_tail(&p_current_route_rule->prefix_list, prefix);
			OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
				"PREFIX:  0x%016" PRIx64 " \n",
				cl_ntoh64(*prefix));
		}
		free(range_arr[i]);
	}
	free(range_arr);
}

/***************************************************
 ***************************************************/
static int __validate_route_rule()
{
	cl_list_iterator_t list_iterator;
	uint64_t prefix;

	if(!p_current_route_rule)
		return -1;

	/* validate route rule name */
	if(p_current_route_rule->name){
		if(strcmp(p_current_route_rule->name, "static")
			&& strcmp(p_current_route_rule->name, "dynamic")
			&& strcmp(p_current_route_rule->name, "default")) {
			OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
				"ERR 9F05: "
				"Invalid name specified"
				" Rule End line No: %d\n",
				route_line_num-3);
			return -1;
		}
		if(!strcmp(p_current_route_rule->name, "default"))
			default_count++;
	}
	else {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F06: "
			"No name specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;
	}

	/* Validate subnet_prefix */
	if(sn_count && cl_list_count(&p_current_route_rule->prefix_list) > 0) {
		for (list_iterator = cl_list_head(&p_current_route_rule->prefix_list);
			list_iterator != cl_list_end(&p_current_route_rule->prefix_list);
			list_iterator = cl_list_next(list_iterator)){
			prefix = *((uint64_t *) cl_list_obj(list_iterator));

			if(!strcmp(p_current_route_rule->name, "static")
				&& !((prefix & IB_LOCAL_SUBNET_MASK) ==
				IB_SITE_LOCAL_SUBNET_PREFIX)){
				OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
					"ERR 9F07: "
					"Invalid static Subnet Prefix"
					": 0x%016" PRIx64
					" Rule End line No: %d\n",
					cl_ntoh64(prefix), route_line_num);
				return -1;
			}
			else if(!strcmp(p_current_route_rule->name, "default")
				&& prefix != 0x0){
				OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
					"ERR 9F08: "
					"Invalid Default Subnet Prefix"
					": 0x%016" PRIx64
					" Rule End line No: %d\n",
					cl_ntoh64(prefix), route_line_num);
				return -1;
			}
		}
	}

	else {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,"ERR 9F09: "
			"No subnet prefix specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;
	}

	if(sn_count > 1) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F0A: "
			"Multiple subnet prefix entry specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;
	}

	/* Validate router Guid */
	if(guid_count == 0) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F0B: "
			"No Router GUID specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;
	}
	else if(guid_count > 1) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F0C: "
			"Multiple Router GUID specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;
	}
	else if(!p_current_route_rule->router_guid) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F0D: "
			"Invalid Router GUID"
			": 0x%016" PRIx64
			" Rule End line No: %d\n",
			p_current_route_rule->router_guid,
			route_line_num);
		return -1;
	}

	/*Validate weight 0 - 10*/
	if(weight_count == 0) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F0E: "
			"No weight specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;
	}
	else if (weight_count > 1) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F0F: "
			"Multiple weight entry specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;

	}
	else if(p_current_route_rule->weight > 10) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F10: "
			"Invalid weight :%d "
			" Rule End line No: %d\n",
			p_current_route_rule->weight,
			route_line_num);
		return -1;
	}

	return 0;
}

/***************************************************
 ***************************************************/
static int __loadguidtomap(cl_list_t * p_list)
{
	int ret = 0;
	void *ptr= NULL;
	uint32_t *percent = NULL;
	uint64_t *range_arr = NULL;
	cl_list_iterator_t list_iterator;

	list_iterator = cl_list_head(p_list);


	while( list_iterator != cl_list_end(p_list) ) {
		range_arr = (uint64_t *)cl_list_obj(list_iterator);
		/* Check for duplicate key */
		ptr = cl_map_get(&p_load_share_rule->load_share_map, cl_hton64(range_arr[0]));

		if(!ptr){
			percent = (uint32_t*)malloc(sizeof(uint32_t));
			if(!percent) {
				OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
					"ERR 9F1C:"
					" Memory allocation failure\n");
				ret = -1;
				free(range_arr);
				break;
			}

			*percent = range_arr[1];
			cl_map_insert(&p_load_share_rule->load_share_map,
					cl_hton64(range_arr[0]), percent);
			list_iterator = cl_list_next(list_iterator);
			free(range_arr);
			ret = 1;
		}
		else {
			OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
				"ERR 9F1E:"
				" Duplicate Router GUID "
				": 0x%016" PRIx64"\n", range_arr[0]);
			free(range_arr);
			ret = -1;
			break;
		}
	}

	cl_list_remove_all(p_list);
	return ret;
}

/***************************************************
 ***************************************************/
static int __validate_load_share_rule()
{
	int percent = 0;
	int ret = -1;
	uint64_t guid;
	cl_map_iterator_t map_it;

	if(sn_count == 0) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F14: "
			"No subnet prefix entry specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;
	}
	else if(sn_count > 1) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F15: "
			"Multiple subnet prefix entry specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;
	}

	if(!((p_load_share_rule->subnet_prefix & IB_LOCAL_SUBNET_MASK) ==
		IB_SITE_LOCAL_SUBNET_PREFIX)){
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
			"ERR 9F11: "
			"Invalid Subnet Prefix"
			": 0x%016" PRIx64
			" Rule End line No: %d\n",
			cl_ntoh64(p_load_share_rule->subnet_prefix),
			route_line_num);
		return -1;
	}

	/* Validate router Guid */
	if(guid_count == 0) {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F16: "
			"No Router GUID specified"
			" Rule End line No: %d\n",
			route_line_num);
		return -1;
	}

	for (map_it = cl_map_head(&p_load_share_rule->load_share_map);
		map_it != cl_map_end(&p_load_share_rule->load_share_map);
		map_it = cl_map_next(map_it)) {
		guid = cl_map_key(map_it);
		percent = percent + *((uint32_t*)cl_map_obj(map_it));

		if((guid == INVALID_GUID) || guid == 0x0) {
			OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
				"ERR 9F12: "
				"Invalid GUID"
				": 0x%016" PRIx64
				" Rule End line No: %d\n",
				cl_ntoh64(guid), route_line_num);
			return -1;
		}

		if(percent > 100) {
			OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR,
				"ERR 9F13: "
				"Invalid total percentage:%d"
				" Rule End line No: %d\n",
				percent, route_line_num);
			return -1;
		}
		ret = 0;
	}

	return ret;
}

/***************************************************
 ***************************************************/
static int __validate_uint64bit_string(char *str)
{
	int len, i;
	char *ptr = str;
	len= strlen(ptr);

	if(len == 18 && !strncmp(ptr, "0x", 2)){
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
			"String :%s String len:%d\n",
			ptr, len);
		ptr +=2;
		for(i = 2; i < len; i++) {
			if(!isxdigit(*ptr))
				return -1;
			ptr += 1;
		}
	}
	else if(len <= 3){
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_DEBUG,
			"String :%s String len:%d\n",
			ptr, len);
		for(i = 0; i < len; i++) {
			if(!isxdigit(*ptr))
				return -1;
			ptr += 1;
		}
	}
	else {
		OSM_LOG(p_route_parser_osm_log, OSM_LOG_ERROR, "ERR 9F1B "
			"Invalid String :%s String len:%d\n",
			ptr, len);
		return -1;
	}
	return 0;
}
