/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "osm_qos_parser_y.y" /* yacc.c:339  */

/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 * Copyright (c) 2004-2009 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2002-2008 Mellanox Technologies LTD. All rights reserved.
 * Copyright (c) 1996-2003 Intel Corporation. All rights reserved.
 * Copyright (c) 2008 HNR Consulting. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

/*
 * Abstract:
 *    Grammar of OSM QoS parser.
 *
 * Environment:
 *    Linux User Mode
 *
 * Author:
 *    Yevgeny Kliteynik, Mellanox
 */

#include <stdio.h>
#include <assert.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_QOS_PARSER_Y_Y
#include <opensm/osm_opensm.h>
#include <opensm/osm_qos_policy.h>
#include <opensm/osm_helper.h>

#define OSM_QOS_POLICY_MAX_LINE_LEN         1024*10
#define OSM_QOS_POLICY_SL2VL_TABLE_LEN      IB_MAX_NUM_VLS
#define OSM_QOS_POLICY_MAX_VL_NUM           IB_MAX_NUM_VLS
#define OSM_QOS_POLICY_MAX_RATE             IB_MAX_RATE
#define OSM_QOS_POLICY_MIN_RATE             IB_MIN_RATE
#define OSM_QOS_POLICY_MAX_MTU              IB_MAX_MTU
#define OSM_QOS_POLICY_MIN_MTU              IB_MIN_MTU

typedef struct tmp_parser_struct_t_ {
    char       str[OSM_QOS_POLICY_MAX_LINE_LEN];
    uint64_t   num_pair[2];
    ib_gid_t   gid_pair[2];
    cl_list_t  str_list;
    cl_list_t  num_list;
    cl_list_t  num_pair_list;
} tmp_parser_struct_t;

static void __parser_tmp_struct_init();
static void __parser_tmp_struct_reset();
static void __parser_tmp_struct_destroy();

static char * __parser_strip_white(char * str);

static void __parser_str2uint64(uint64_t * p_val, char * str);

static void __parser_port_group_start();
static int __parser_port_group_end();

static void __parser_sl2vl_scope_start();
static int __parser_sl2vl_scope_end();

static void __parser_vlarb_scope_start();
static int __parser_vlarb_scope_end();

static void __parser_qos_level_start();
static int __parser_qos_level_end();

static void __parser_match_rule_start();
static int __parser_match_rule_end();

static void __parser_ulp_match_rule_start();
static int __parser_ulp_match_rule_end();

static void __parser_str2gid(ib_gid_t * p_val, char * str);

static void __pkey_rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len);

static void __rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len);

inline static int __cmp_gids(ib_gid_t gid1, ib_gid_t gid2);

static void __gidrangelist2rangearr(
    cl_list_t    * p_list,
    ib_gid_t  ** * p_arr,
    unsigned     * p_arr_len);

static void __merge_rangearr(
    uint64_t  **   range_arr_1,
    unsigned       range_len_1,
    uint64_t  **   range_arr_2,
    unsigned       range_len_2,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len );

static void __parser_add_port_to_port_map(
    cl_qmap_t   * p_map,
    osm_physp_t * p_physp);

static void __parser_add_guid_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len);

static void __parser_add_prefix_range_to_prefix_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned	 range_len);

static void __parser_add_gid_range_to_gid_map(
    cl_qmap_t   * p_map,
    ib_gid_t   ** p_arr,
    unsigned	  range_len);

static void __parser_add_pkey_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len);

static void __parser_add_partition_list_to_port_map(
    cl_qmap_t  * p_map,
    cl_list_t  * p_list);

static void __parser_add_map_to_port_map(
    cl_qmap_t * p_dmap,
    cl_map_t  * p_smap);

static int __validate_pkeys(
    uint64_t ** range_arr,
    unsigned    range_len,
    boolean_t   is_ipoib);

static void __setup_simple_qos_levels();
static void __clear_simple_qos_levels();
static void __setup_ulp_match_rules();
static void __process_ulp_match_rules();
static void yyerror(const char *format, ...);

extern char * yytext;
extern int yylex (void);
extern FILE * yyin;
extern int errno;
extern void yyrestart(FILE *input_file);
extern YYSTYPE yylval;
int yyparse();

#define RESET_BUFFER  __parser_tmp_struct_reset()

tmp_parser_struct_t tmp_parser_struct;

int column_num;
int line_num;

osm_qos_policy_t       * p_qos_policy = NULL;
osm_qos_port_group_t   * p_current_port_group = NULL;
osm_qos_sl2vl_scope_t  * p_current_sl2vl_scope = NULL;
osm_qos_vlarb_scope_t  * p_current_vlarb_scope = NULL;
osm_qos_level_t        * p_current_qos_level = NULL;
osm_qos_match_rule_t   * p_current_qos_match_rule = NULL;
osm_log_t              * p_qos_parser_osm_log;

/* 16 Simple QoS Levels - one for each SL */
static osm_qos_level_t osm_qos_policy_simple_qos_levels[16];

/* Default Simple QoS Level */
osm_qos_level_t __default_simple_qos_level;

/*
 * List of match rules that will be generated by the
 * qos-ulp section. These rules are concatenated to
 * the end of the usual matching rules list at the
 * end of parsing.
 */
static cl_list_t __ulp_match_rules;

/***************************************************/


#line 282 "osm_qos_parser_y.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_OSM_QOS_PARSER_Y_H_INCLUDED
# define YY_YY_OSM_QOS_PARSER_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TK_NUMBER = 258,
    TK_DASH = 259,
    TK_DOTDOT = 260,
    TK_COMMA = 261,
    TK_ASTERISK = 262,
    TK_TEXT = 263,
    TK_IPV6_ADDR = 264,
    TK_QOS_ULPS_START = 265,
    TK_QOS_ULPS_END = 266,
    TK_PORT_GROUPS_START = 267,
    TK_PORT_GROUPS_END = 268,
    TK_PORT_GROUP_START = 269,
    TK_PORT_GROUP_END = 270,
    TK_QOS_SETUP_START = 271,
    TK_QOS_SETUP_END = 272,
    TK_VLARB_TABLES_START = 273,
    TK_VLARB_TABLES_END = 274,
    TK_VLARB_SCOPE_START = 275,
    TK_VLARB_SCOPE_END = 276,
    TK_SL2VL_TABLES_START = 277,
    TK_SL2VL_TABLES_END = 278,
    TK_SL2VL_SCOPE_START = 279,
    TK_SL2VL_SCOPE_END = 280,
    TK_QOS_LEVELS_START = 281,
    TK_QOS_LEVELS_END = 282,
    TK_QOS_LEVEL_START = 283,
    TK_QOS_LEVEL_END = 284,
    TK_QOS_MATCH_RULES_START = 285,
    TK_QOS_MATCH_RULES_END = 286,
    TK_QOS_MATCH_RULE_START = 287,
    TK_QOS_MATCH_RULE_END = 288,
    TK_NAME = 289,
    TK_USE = 290,
    TK_PORT_GUID = 291,
    TK_PORT_GID = 292,
    TK_SUBNET_PREFIX = 293,
    TK_PORT_NAME = 294,
    TK_PARTITION = 295,
    TK_NODE_TYPE = 296,
    TK_GROUP = 297,
    TK_ACROSS = 298,
    TK_VLARB_HIGH = 299,
    TK_VLARB_LOW = 300,
    TK_VLARB_HIGH_LIMIT = 301,
    TK_TO = 302,
    TK_FROM = 303,
    TK_ACROSS_TO = 304,
    TK_ACROSS_FROM = 305,
    TK_SL2VL_TABLE = 306,
    TK_SL = 307,
    TK_MTU_LIMIT = 308,
    TK_RATE_LIMIT = 309,
    TK_PACKET_LIFE = 310,
    TK_PATH_BITS = 311,
    TK_QOS_CLASS = 312,
    TK_SOURCE = 313,
    TK_DESTINATION = 314,
    TK_SERVICE_ID = 315,
    TK_QOS_LEVEL_NAME = 316,
    TK_PKEY = 317,
    TK_NODE_TYPE_ROUTER = 318,
    TK_NODE_TYPE_CA = 319,
    TK_NODE_TYPE_SWITCH = 320,
    TK_NODE_TYPE_SELF = 321,
    TK_NODE_TYPE_ALL = 322,
    TK_ULP_DEFAULT = 323,
    TK_ULP_ANY_SERVICE_ID = 324,
    TK_ULP_ANY_PKEY = 325,
    TK_ULP_ANY_TARGET_PORT_GUID = 326,
    TK_ULP_ANY_SOURCE_PORT_GUID = 327,
    TK_ULP_ANY_SOURCE_TARGET_PORT_GUID = 328,
    TK_ULP_ANY_TARGET_SUBNET_PREFIX = 329,
    TK_ULP_SDP_DEFAULT = 330,
    TK_ULP_SDP_PORT = 331,
    TK_ULP_RDS_DEFAULT = 332,
    TK_ULP_RDS_PORT = 333,
    TK_ULP_ISER_DEFAULT = 334,
    TK_ULP_ISER_PORT = 335,
    TK_ULP_SRP_GUID = 336,
    TK_ULP_IPOIB_DEFAULT = 337,
    TK_ULP_IPOIB_PKEY = 338
  };
#endif
/* Tokens.  */
#define TK_NUMBER 258
#define TK_DASH 259
#define TK_DOTDOT 260
#define TK_COMMA 261
#define TK_ASTERISK 262
#define TK_TEXT 263
#define TK_IPV6_ADDR 264
#define TK_QOS_ULPS_START 265
#define TK_QOS_ULPS_END 266
#define TK_PORT_GROUPS_START 267
#define TK_PORT_GROUPS_END 268
#define TK_PORT_GROUP_START 269
#define TK_PORT_GROUP_END 270
#define TK_QOS_SETUP_START 271
#define TK_QOS_SETUP_END 272
#define TK_VLARB_TABLES_START 273
#define TK_VLARB_TABLES_END 274
#define TK_VLARB_SCOPE_START 275
#define TK_VLARB_SCOPE_END 276
#define TK_SL2VL_TABLES_START 277
#define TK_SL2VL_TABLES_END 278
#define TK_SL2VL_SCOPE_START 279
#define TK_SL2VL_SCOPE_END 280
#define TK_QOS_LEVELS_START 281
#define TK_QOS_LEVELS_END 282
#define TK_QOS_LEVEL_START 283
#define TK_QOS_LEVEL_END 284
#define TK_QOS_MATCH_RULES_START 285
#define TK_QOS_MATCH_RULES_END 286
#define TK_QOS_MATCH_RULE_START 287
#define TK_QOS_MATCH_RULE_END 288
#define TK_NAME 289
#define TK_USE 290
#define TK_PORT_GUID 291
#define TK_PORT_GID 292
#define TK_SUBNET_PREFIX 293
#define TK_PORT_NAME 294
#define TK_PARTITION 295
#define TK_NODE_TYPE 296
#define TK_GROUP 297
#define TK_ACROSS 298
#define TK_VLARB_HIGH 299
#define TK_VLARB_LOW 300
#define TK_VLARB_HIGH_LIMIT 301
#define TK_TO 302
#define TK_FROM 303
#define TK_ACROSS_TO 304
#define TK_ACROSS_FROM 305
#define TK_SL2VL_TABLE 306
#define TK_SL 307
#define TK_MTU_LIMIT 308
#define TK_RATE_LIMIT 309
#define TK_PACKET_LIFE 310
#define TK_PATH_BITS 311
#define TK_QOS_CLASS 312
#define TK_SOURCE 313
#define TK_DESTINATION 314
#define TK_SERVICE_ID 315
#define TK_QOS_LEVEL_NAME 316
#define TK_PKEY 317
#define TK_NODE_TYPE_ROUTER 318
#define TK_NODE_TYPE_CA 319
#define TK_NODE_TYPE_SWITCH 320
#define TK_NODE_TYPE_SELF 321
#define TK_NODE_TYPE_ALL 322
#define TK_ULP_DEFAULT 323
#define TK_ULP_ANY_SERVICE_ID 324
#define TK_ULP_ANY_PKEY 325
#define TK_ULP_ANY_TARGET_PORT_GUID 326
#define TK_ULP_ANY_SOURCE_PORT_GUID 327
#define TK_ULP_ANY_SOURCE_TARGET_PORT_GUID 328
#define TK_ULP_ANY_TARGET_SUBNET_PREFIX 329
#define TK_ULP_SDP_DEFAULT 330
#define TK_ULP_SDP_PORT 331
#define TK_ULP_RDS_DEFAULT 332
#define TK_ULP_RDS_PORT 333
#define TK_ULP_ISER_DEFAULT 334
#define TK_ULP_ISER_PORT 335
#define TK_ULP_SRP_GUID 336
#define TK_ULP_IPOIB_DEFAULT 337
#define TK_ULP_IPOIB_PKEY 338

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_OSM_QOS_PARSER_Y_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 499 "osm_qos_parser_y.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   300

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  84
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  180
/* YYNRULES -- Number of rules.  */
#define YYNRULES  261
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  366

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   338

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   312,   312,   315,   316,   319,   320,   321,   322,   323,
     349,   352,   353,   382,   385,   386,   389,   392,   397,   403,
     404,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     442,   445,   446,   447,   452,   455,   456,   459,   462,   467,
     473,   474,   489,   490,   491,   492,   493,   498,   501,   502,
     505,   508,   513,   519,   520,   539,   540,   541,   542,   543,
     544,   545,   569,   572,   573,   576,   579,   584,   590,   591,
     594,   595,   596,   597,   598,   599,   600,   601,   623,   626,
     627,   630,   633,   638,   644,   645,   648,   649,   650,   651,
     652,   653,   654,   678,   696,   696,   717,   717,   738,   738,
     773,   773,   808,   808,   846,   846,   882,   882,   895,   895,
     929,   929,   942,   942,   976,   976,   989,   989,  1023,  1023,
    1059,  1059,  1082,  1082,  1115,  1118,  1121,  1124,  1127,  1130,
    1133,  1136,  1139,  1142,  1145,  1148,  1151,  1154,  1157,  1161,
    1200,  1223,  1228,  1251,  1256,  1322,  1327,  1347,  1352,  1372,
    1377,  1397,  1403,  1423,  1428,  1436,  1441,  1446,  1451,  1452,
    1455,  1456,  1457,  1458,  1459,  1462,  1468,  1474,  1480,  1488,
    1510,  1527,  1532,  1549,  1554,  1572,  1577,  1594,  1599,  1616,
    1632,  1649,  1654,  1673,  1678,  1695,  1700,  1718,  1723,  1728,
    1733,  1738,  1743,  1744,  1747,  1754,  1755,  1758,  1765,  1796,
    1828,  1871,  1888,  1911,  1916,  1939,  1944,  1964,  1969,  1996,
    2002,  2029,  2035,  2055,  2061,  2096,  2101,  2134,  2151,  2174,
    2179,  2213,  2218,  2235,  2240,  2257,  2262,  2285,  2290,  2323,
    2328,  2361,  2372,  2379,  2380,  2383,  2394,  2395,  2400,  2403,
    2404,  2407,  2416,  2422,  2430,  2437,  2444,  2447,  2453,  2465,
    2477,  2485,  2493,  2500,  2507,  2510,  2516,  2529,  2542,  2550,
    2558,  2565
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TK_NUMBER", "TK_DASH", "TK_DOTDOT",
  "TK_COMMA", "TK_ASTERISK", "TK_TEXT", "TK_IPV6_ADDR",
  "TK_QOS_ULPS_START", "TK_QOS_ULPS_END", "TK_PORT_GROUPS_START",
  "TK_PORT_GROUPS_END", "TK_PORT_GROUP_START", "TK_PORT_GROUP_END",
  "TK_QOS_SETUP_START", "TK_QOS_SETUP_END", "TK_VLARB_TABLES_START",
  "TK_VLARB_TABLES_END", "TK_VLARB_SCOPE_START", "TK_VLARB_SCOPE_END",
  "TK_SL2VL_TABLES_START", "TK_SL2VL_TABLES_END", "TK_SL2VL_SCOPE_START",
  "TK_SL2VL_SCOPE_END", "TK_QOS_LEVELS_START", "TK_QOS_LEVELS_END",
  "TK_QOS_LEVEL_START", "TK_QOS_LEVEL_END", "TK_QOS_MATCH_RULES_START",
  "TK_QOS_MATCH_RULES_END", "TK_QOS_MATCH_RULE_START",
  "TK_QOS_MATCH_RULE_END", "TK_NAME", "TK_USE", "TK_PORT_GUID",
  "TK_PORT_GID", "TK_SUBNET_PREFIX", "TK_PORT_NAME", "TK_PARTITION",
  "TK_NODE_TYPE", "TK_GROUP", "TK_ACROSS", "TK_VLARB_HIGH", "TK_VLARB_LOW",
  "TK_VLARB_HIGH_LIMIT", "TK_TO", "TK_FROM", "TK_ACROSS_TO",
  "TK_ACROSS_FROM", "TK_SL2VL_TABLE", "TK_SL", "TK_MTU_LIMIT",
  "TK_RATE_LIMIT", "TK_PACKET_LIFE", "TK_PATH_BITS", "TK_QOS_CLASS",
  "TK_SOURCE", "TK_DESTINATION", "TK_SERVICE_ID", "TK_QOS_LEVEL_NAME",
  "TK_PKEY", "TK_NODE_TYPE_ROUTER", "TK_NODE_TYPE_CA",
  "TK_NODE_TYPE_SWITCH", "TK_NODE_TYPE_SELF", "TK_NODE_TYPE_ALL",
  "TK_ULP_DEFAULT", "TK_ULP_ANY_SERVICE_ID", "TK_ULP_ANY_PKEY",
  "TK_ULP_ANY_TARGET_PORT_GUID", "TK_ULP_ANY_SOURCE_PORT_GUID",
  "TK_ULP_ANY_SOURCE_TARGET_PORT_GUID", "TK_ULP_ANY_TARGET_SUBNET_PREFIX",
  "TK_ULP_SDP_DEFAULT", "TK_ULP_SDP_PORT", "TK_ULP_RDS_DEFAULT",
  "TK_ULP_RDS_PORT", "TK_ULP_ISER_DEFAULT", "TK_ULP_ISER_PORT",
  "TK_ULP_SRP_GUID", "TK_ULP_IPOIB_DEFAULT", "TK_ULP_IPOIB_PKEY",
  "$accept", "head", "qos_policy_entries", "qos_policy_entry",
  "qos_ulps_section", "qos_ulps", "port_groups_section", "port_groups",
  "port_group", "port_group_start", "port_group_end", "port_group_entries",
  "port_group_entry", "qos_setup_section", "qos_setup_items",
  "vlarb_tables", "vlarb_scope_items", "vlarb_scope", "vlarb_scope_start",
  "vlarb_scope_end", "vlarb_scope_entries", "vlarb_scope_entry",
  "sl2vl_tables", "sl2vl_scope_items", "sl2vl_scope", "sl2vl_scope_start",
  "sl2vl_scope_end", "sl2vl_scope_entries", "sl2vl_scope_entry",
  "qos_levels_section", "qos_levels", "qos_level", "qos_level_start",
  "qos_level_end", "qos_level_entries", "qos_level_entry",
  "qos_match_rules_section", "qos_match_rules", "qos_match_rule",
  "qos_match_rule_start", "qos_match_rule_end", "qos_match_rule_entries",
  "qos_match_rule_entry", "qos_ulp", "$@1", "$@2", "$@3", "$@4", "$@5",
  "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13", "$@14",
  "$@15", "qos_ulp_type_any_service", "qos_ulp_type_any_pkey",
  "qos_ulp_type_any_target_port_guid", "qos_ulp_type_any_source_port_guid",
  "qos_ulp_type_any_source_target_port_guid",
  "qos_ulp_type_any_target_subnet_prefix", "qos_ulp_type_sdp_default",
  "qos_ulp_type_sdp_port", "qos_ulp_type_rds_default",
  "qos_ulp_type_rds_port", "qos_ulp_type_iser_default",
  "qos_ulp_type_iser_port", "qos_ulp_type_srp_guid",
  "qos_ulp_type_ipoib_default", "qos_ulp_type_ipoib_pkey", "qos_ulp_sl",
  "port_group_name", "port_group_name_start", "port_group_use",
  "port_group_use_start", "port_group_port_name",
  "port_group_port_name_start", "port_group_port_guid",
  "port_group_port_guid_start", "port_group_prefix",
  "port_group_subnet_prefix_start", "port_group_gid",
  "port_group_port_gid_start", "port_group_pkey", "port_group_pkey_start",
  "port_group_partition", "port_group_partition_start",
  "port_group_node_type", "port_group_node_type_start",
  "port_group_node_type_list", "node_type_item", "node_type_ca",
  "node_type_switch", "node_type_router", "node_type_all",
  "node_type_self", "vlarb_scope_group", "vlarb_scope_group_start",
  "vlarb_scope_across", "vlarb_scope_across_start",
  "vlarb_scope_vlarb_high_limit", "vlarb_scope_vlarb_high_limit_start",
  "vlarb_scope_vlarb_high", "vlarb_scope_vlarb_high_start",
  "vlarb_scope_vlarb_low", "vlarb_scope_vlarb_low_start",
  "sl2vl_scope_group", "sl2vl_scope_group_start", "sl2vl_scope_across",
  "sl2vl_scope_across_start", "sl2vl_scope_across_from",
  "sl2vl_scope_across_from_start", "sl2vl_scope_across_to",
  "sl2vl_scope_across_to_start", "sl2vl_scope_from",
  "sl2vl_scope_from_start", "sl2vl_scope_to", "sl2vl_scope_to_start",
  "sl2vl_scope_from_list_or_asterisk", "sl2vl_scope_from_asterisk",
  "sl2vl_scope_to_list_or_asterisk", "sl2vl_scope_to_asterisk",
  "sl2vl_scope_from_list_of_ranges", "sl2vl_scope_to_list_of_ranges",
  "sl2vl_scope_sl2vl_table", "sl2vl_scope_sl2vl_table_start",
  "qos_level_name", "qos_level_name_start", "qos_level_use",
  "qos_level_use_start", "qos_level_sl", "qos_level_sl_start",
  "qos_level_mtu_limit", "qos_level_mtu_limit_start",
  "qos_level_rate_limit", "qos_level_rate_limit_start",
  "qos_level_packet_life", "qos_level_packet_life_start",
  "qos_level_path_bits", "qos_level_path_bits_start", "qos_level_pkey",
  "qos_level_pkey_start", "qos_match_rule_use", "qos_match_rule_use_start",
  "qos_match_rule_qos_class", "qos_match_rule_qos_class_start",
  "qos_match_rule_source", "qos_match_rule_source_start",
  "qos_match_rule_destination", "qos_match_rule_destination_start",
  "qos_match_rule_qos_level_name", "qos_match_rule_qos_level_name_start",
  "qos_match_rule_service_id", "qos_match_rule_service_id_start",
  "qos_match_rule_pkey", "qos_match_rule_pkey_start", "single_string",
  "single_string_elems", "single_string_element", "string_list",
  "single_number", "num_list", "number", "num_list_with_dotdot",
  "number_from_pair_1", "number_from_pair_2", "list_of_ranges",
  "num_list_with_dash", "single_number_from_range", "number_from_range_1",
  "number_from_range_2", "list_of_gid_ranges", "gid_list_with_dash",
  "single_gid_from_range", "gid_from_range_1", "gid_from_range_2", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338
};
# endif

#define YYPACT_NINF -315

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-315)))

#define YYTABLE_NINF -261

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -315,    22,    17,  -315,    79,    10,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,    39,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,    -2,  -315,    45,    45,    45,    45,    45,    45,  -315,
      45,  -315,    45,  -315,    45,    45,  -315,    45,  -315,    43,
    -315,  -315,     1,     3,    29,  -315,  -315,  -315,  -315,  -315,
      28,    53,    57,  -315,    84,    85,    92,    94,    96,    97,
      39,    98,    39,   101,    39,   102,   108,    39,   112,  -315,
    -315,     0,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,    45,   115,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,   113,  -315,   113,  -315,
     113,  -315,    45,  -315,    45,  -315,   125,  -315,    45,  -315,
     113,  -315,   100,    74,    72,    30,    -7,    39,  -315,   118,
    -315,  -315,    39,    39,    39,    39,    39,    39,    39,    39,
      39,    39,  -315,  -315,   113,  -315,  -315,  -315,    99,  -315,
    -315,   131,  -315,   130,  -315,   135,  -315,    99,  -315,  -315,
    -315,  -315,  -315,   134,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
     113,  -315,   113,  -315,    39,  -315,    39,  -315,    39,  -315,
      39,  -315,    45,  -315,    45,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,   113,  -315,    45,  -315,
     113,  -315,   113,  -315,   113,  -315,    45,  -315,    45,  -315,
     115,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,   113,   125,   159,   100,    66,    95,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,    99,    99,
    -315,  -315,  -315,  -315,  -315,  -315,   165,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,   113,
    -315,   113,  -315,    39,  -315,   167,  -315,   167,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,   113,
    -315,   113,  -315,   113,  -315,   113,  -315,    13,  -315,    18,
    -315,    39,   159,    99,    99,  -315,  -315,   166,   169,   166,
      99,    99,    99,    99,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,   170,  -315,  -315,   167,   168,    39,
     172,  -315,  -315,  -315,   168,  -315
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       3,     0,     2,     1,     0,     0,    31,    63,    79,     4,
       5,     6,     7,     8,     9,     0,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,     0,    11,     0,     0,     0,     0,     0,     0,   106,
       0,   110,     0,   114,     0,     0,   120,     0,    17,     0,
      14,    19,     0,     0,     0,   241,    93,   238,    10,    12,
     251,     0,   246,   247,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    13,
      15,     0,    30,    35,    48,    32,    33,    62,    66,    64,
      68,    78,    82,    80,    84,    94,     0,     0,    96,    98,
     100,   102,   104,   107,   139,   108,   111,   112,   115,   116,
     118,   121,   122,    18,   141,   143,   147,   151,   149,   145,
     155,   157,   153,    16,    20,    21,     0,    22,     0,    26,
       0,    23,     0,    24,     0,    25,     0,    27,     0,    28,
       0,    29,     0,     0,     0,     0,     0,     0,   250,     0,
     253,   248,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   140,   232,   233,   142,   236,   144,   146,
     148,   259,   150,   254,   255,     0,   152,   154,   167,   165,
     166,   169,   168,   156,   158,   160,   161,   162,   163,   164,
      34,    38,    36,    40,    47,    51,    49,    53,    67,   203,
     205,   207,   209,   211,   213,   215,   217,    65,    69,    70,
       0,    71,     0,    72,     0,    73,     0,    74,     0,    75,
       0,    76,     0,    77,     0,    83,   219,   221,   223,   225,
     229,   227,   231,    81,    85,    86,     0,    87,     0,    89,
       0,    90,     0,    88,     0,    91,     0,    92,     0,    95,
       0,    97,    99,   101,   103,   105,   109,   113,   117,   119,
     123,   234,     0,     0,     0,     0,     0,     0,   202,   204,
     206,   208,   210,   212,   214,   216,   218,   220,   222,   224,
     226,   228,   230,   249,   237,   258,     0,   261,   256,   159,
      39,   171,   173,   177,   179,   175,    37,    41,    42,     0,
      43,     0,    46,     0,    44,     0,    45,     0,    52,   181,
     183,   191,   189,   187,   185,   201,    50,    54,    55,     0,
      56,     0,    57,     0,    58,     0,    59,     0,    60,     0,
      61,     0,     0,   170,   172,   174,   244,   176,     0,   178,
     180,   182,   184,   186,   194,   188,   192,   193,   198,   197,
     190,   195,   196,   199,   200,   239,   257,     0,     0,     0,
       0,   245,   242,   240,     0,   243
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,   129,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,   148,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,   -28,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,   -85,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,  -315,
    -121,  -315,    19,  -126,    -3,  -315,  -314,  -125,  -176,  -180,
     -34,  -315,    89,    90,   -63,  -315,  -315,   -74,   -72,  -140
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     9,    10,    31,    11,    49,    50,    51,
     123,    81,   124,    12,    52,    85,   143,   192,   193,   296,
     266,   297,    86,   144,   196,   197,   316,   267,   317,    13,
      53,    89,    90,   207,   145,   208,    14,    54,    93,    94,
     233,   146,   234,    32,   147,   152,   153,   154,   155,   156,
      70,   157,    72,   158,    74,   159,   160,    77,   161,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,   103,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   183,   184,   185,   186,   187,   188,   189,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   345,   346,   350,   351,   347,   352,   330,   331,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     167,   164,   165,   168,   104,   354,    57,   337,   338,   362,
      61,    62,    63,    64,   151,   172,   173,   174,   175,   288
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      65,    66,    67,    68,    69,   163,    71,   166,    73,    58,
      75,    76,    56,    78,   177,   113,    60,   355,    82,    83,
     344,    60,     3,    84,    48,   349,   225,     4,   226,     5,
      87,    88,  -252,     6,   114,   115,   116,   117,   118,   119,
     120,   121,    55,     7,   106,   363,   108,     8,    60,   111,
     227,   228,   229,   230,   231,   232,    79,    48,    95,   198,
      91,    92,   122,    96,   199,   200,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   201,   202,   203,   204,   205,   290,    97,   268,
      98,   269,   206,   190,   191,   194,   195,    99,   169,   100,
     170,   101,   102,   105,   176,   262,   107,   109,   291,   292,
     293,   294,   295,   110,   278,   276,   279,   112,   150,   249,
     308,   162,   250,   280,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   171,  -260,   263,   309,   310,   264,
     265,   284,   311,   312,   313,   314,   315,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   178,   179,   180,   181,   182,   287,   332,
     336,   361,   357,   333,   358,   334,   359,   364,    80,    59,
     289,   360,   339,   261,   365,   148,   149,   283,   274,   285,
     275,   286,   356,   340,     0,   341,     0,   342,     0,   343,
       0,     0,     0,     0,   277,     0,     0,     0,     0,     0,
       0,   270,   281,   271,   282,   272,     0,   273,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   348,     0,   353,     0,     0,     0,     0,
     335
};

static const yytype_int16 yycheck[] =
{
      34,    35,    36,    37,    38,   126,    40,   128,    42,    11,
      44,    45,    15,    47,   140,    15,     3,   331,    17,    18,
       7,     3,     0,    22,    14,     7,    33,    10,    35,    12,
      27,    28,     4,    16,    34,    35,    36,    37,    38,    39,
      40,    41,     3,    26,    72,   359,    74,    30,     3,    77,
      57,    58,    59,    60,    61,    62,    13,    14,     5,    29,
      31,    32,    62,     6,    34,    35,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    52,    53,    54,    55,    56,    21,     4,   210,
       5,   212,    62,    19,    20,    23,    24,     5,   132,     5,
     134,     5,     5,     5,   138,     6,     5,     5,    42,    43,
      44,    45,    46,     5,   240,   236,   242,     5,     3,   147,
      25,     8,     4,   244,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,     9,     4,     6,    42,    43,     4,
       6,   262,    47,    48,    49,    50,    51,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    63,    64,    65,    66,    67,     9,     4,
       3,     3,     6,   299,     5,   301,     6,     5,    49,    31,
     265,   357,   307,   164,   364,    96,    96,   250,   222,   263,
     224,   263,   332,   319,    -1,   321,    -1,   323,    -1,   325,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,   214,   246,   216,   248,   218,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   327,    -1,   329,    -1,    -1,    -1,    -1,
     303
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    85,    86,     0,    10,    12,    16,    26,    30,    87,
      88,    90,    97,   113,   120,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    89,   127,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,    14,    91,
      92,    93,    98,   114,   121,     3,   248,   250,    11,   127,
       3,   254,   255,   256,   257,   254,   254,   254,   254,   254,
     134,   254,   136,   254,   138,   254,   254,   141,   254,    13,
      92,    95,    17,    18,    22,    99,   106,    27,    28,   115,
     116,    31,    32,   122,   123,     5,     6,     4,     5,     5,
       5,     5,     5,   158,   248,     5,   158,     5,   158,     5,
       5,   158,     5,    15,    34,    35,    36,    37,    38,    39,
      40,    41,    62,    94,    96,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   100,   107,   118,   125,   128,   256,   257,
       3,   258,   129,   130,   131,   132,   133,   135,   137,   139,
     140,   142,     8,   244,   245,   246,   244,   244,   247,   254,
     254,     9,   259,   260,   261,   262,   254,   247,    63,    64,
      65,    66,    67,   177,   178,   179,   180,   181,   182,   183,
      19,    20,   101,   102,    23,    24,   108,   109,    29,    34,
      35,    52,    53,    54,    55,    56,    62,   117,   119,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    33,    35,    57,    58,    59,
      60,    61,    62,   124,   126,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   158,
       4,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   246,     6,     6,     4,     6,   104,   111,   244,   244,
     248,   248,   248,   248,   254,   254,   244,   254,   247,   247,
     244,   254,   254,   258,   244,   261,   262,     9,   263,   178,
      21,    42,    43,    44,    45,    46,   103,   105,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,    25,    42,
      43,    47,    48,    49,    50,    51,   110,   112,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     212,   213,     4,   247,   247,   248,     3,   251,   252,   251,
     247,   247,   247,   247,     7,   206,   207,   210,   254,     7,
     208,   209,   211,   254,   249,   250,   263,     6,     5,     6,
     252,     3,   253,   250,     5,   253
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,    84,    85,    86,    86,    87,    87,    87,    87,    87,
      88,    89,    89,    90,    91,    91,    92,    93,    94,    95,
      95,    96,    96,    96,    96,    96,    96,    96,    96,    96,
      97,    98,    98,    98,    99,   100,   100,   101,   102,   103,
     104,   104,   105,   105,   105,   105,   105,   106,   107,   107,
     108,   109,   110,   111,   111,   112,   112,   112,   112,   112,
     112,   112,   113,   114,   114,   115,   116,   117,   118,   118,
     119,   119,   119,   119,   119,   119,   119,   119,   120,   121,
     121,   122,   123,   124,   125,   125,   126,   126,   126,   126,
     126,   126,   126,   127,   128,   127,   129,   127,   130,   127,
     131,   127,   132,   127,   133,   127,   134,   127,   135,   127,
     136,   127,   137,   127,   138,   127,   139,   127,   140,   127,
     141,   127,   142,   127,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   177,
     178,   178,   178,   178,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   206,   207,   208,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   245,   246,   247,   247,   248,   249,
     249,   250,   251,   251,   252,   253,   254,   255,   255,   255,
     255,   256,   257,   258,   259,   260,   260,   260,   260,   261,
     262,   263
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       3,     1,     2,     3,     1,     2,     3,     1,     1,     0,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     0,     2,     2,     3,     0,     2,     3,     1,     1,
       0,     2,     1,     1,     1,     1,     1,     3,     0,     2,
       3,     1,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     0,     2,     3,     1,     1,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     0,
       2,     3,     1,     1,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     0,     5,     0,     5,     0,     5,
       0,     5,     0,     5,     0,     5,     0,     3,     0,     5,
       0,     3,     0,     5,     0,     3,     0,     5,     0,     5,
       0,     3,     0,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     1,     1,     2,     1,     1,     3,     1,     1,
       3,     1,     3,     5,     1,     1,     1,     1,     3,     5,
       3,     1,     1,     1,     1,     1,     3,     5,     3,     1,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 17:
#line 392 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_port_group_start();
                    }
#line 1950 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 18:
#line 397 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_port_group_end() )
                            return 1;
                    }
#line 1959 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 38:
#line 462 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_vlarb_scope_start();
                    }
#line 1967 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 39:
#line 467 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_vlarb_scope_end() )
                            return 1;
                    }
#line 1976 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 51:
#line 508 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_sl2vl_scope_start();
                    }
#line 1984 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 52:
#line 513 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_sl2vl_scope_end() )
                            return 1;
                    }
#line 1993 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 66:
#line 579 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_qos_level_start();
                    }
#line 2001 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 67:
#line 584 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_qos_level_end() )
                            return 1;
                    }
#line 2010 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 82:
#line 633 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_match_rule_start();
                    }
#line 2018 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 83:
#line 638 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_match_rule_end() )
                            return 1;
                    }
#line 2027 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 93:
#line 678 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* parsing default ulp rule: "default: num" */
                        cl_list_iterator_t    list_iterator;
                        uint64_t            * p_tmp_num;

                        list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                        p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
                        if (*p_tmp_num > 15)
                        {
                            yyerror("illegal SL value");
                            return 1;
                        }
                        __default_simple_qos_level.sl = (uint8_t)(*p_tmp_num);
                        __default_simple_qos_level.sl_set = TRUE;
                        free(p_tmp_num);
                        cl_list_remove_all(&tmp_parser_struct.num_list);
                    }
#line 2049 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 94:
#line 696 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "any, service-id ... : sl" - one instance of list of ranges */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("ULP rule doesn't have service ids");
                            return 1;
                        }

                        /* get all the service id ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2074 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 96:
#line 717 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "any, pkey ... : sl" - one instance of list of ranges */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("ULP rule doesn't have pkeys");
                            return 1;
                        }

                        /* get all the pkey ranges */
                        __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        p_current_qos_match_rule->pkey_range_arr = range_arr;
                        p_current_qos_match_rule->pkey_range_len = range_len;

                    }
#line 2099 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 98:
#line 738 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* any, target-port-guid ... : sl */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("ULP rule doesn't have port guids");
                            return 1;
                        }

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Targets_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the destination
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->destination_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

                    }
#line 2138 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 100:
#line 773 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			/* any, source-port-guid ... : sl */
			uint64_t ** range_arr;
			unsigned    range_len;

			if (!cl_list_count(&tmp_parser_struct.num_pair_list))
			{
				yyerror("ULP rule doesn't have port guids");
				return 1;
			}

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Sources_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the source
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->source_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

		    }
#line 2177 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 102:
#line 808 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			/* any, source-target-port-guid ... : sl */
			uint64_t ** range_arr;
			unsigned    range_len;

			if (!cl_list_count(&tmp_parser_struct.num_pair_list))
			{
				yyerror("ULP rule doesn't have port guids");
				return 1;
			}

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Sources_Targets_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the source and destination
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->source_group_list,
                                            p_current_port_group);

                        cl_list_insert_tail(&p_current_qos_match_rule->destination_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

		    }
#line 2219 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 104:
#line 846 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			uint64_t ** range_arr;
			unsigned range_len;

			if (!cl_list_count(&tmp_parser_struct.num_pair_list)) {
				yyerror("ULP rule doesn't have subnet prefixes");
				return 1;
			}

                        /* create a new port group with these prefixes */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Targets_");
                        p_current_port_group->use =
			    strdup("Generated from ULP rules");
			__rangelist2rangearr(&tmp_parser_struct.num_pair_list,
					     &range_arr,
					     &range_len);

			__parser_add_prefix_range_to_prefix_map(
			    &p_current_port_group->prefix_map,
			    range_arr,
			    range_len);

                        /*
			 * Add this port group to the destination groups of
			 * current match rule
			 */
                        cl_list_insert_tail(&p_current_qos_match_rule->
					    destination_group_list,
					    p_current_port_group);

                        __parser_port_group_end();

		    }
#line 2259 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 106:
#line 882 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "sdp : sl" - default SL for SDP */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = OSM_QOS_POLICY_ULP_SDP_SERVICE_ID;
                        range_arr[0][1] = OSM_QOS_POLICY_ULP_SDP_SERVICE_ID + 0xFFFF;

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = 1;

                    }
#line 2276 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 108:
#line 895 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* sdp with port numbers */
                        uint64_t ** range_arr;
                        unsigned    range_len;
                        unsigned    i;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("SDP ULP rule doesn't have port numbers");
                            return 1;
                        }

                        /* get all the port ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );
                        /* now translate these port numbers into service ids */
                        for (i = 0; i < range_len; i++)
                        {
                            if (range_arr[i][0] > 0xFFFF || range_arr[i][1] > 0xFFFF)
                            {
                                yyerror("SDP port number out of range");
				free(range_arr);
                                return 1;
                            }
                            range_arr[i][0] += OSM_QOS_POLICY_ULP_SDP_SERVICE_ID;
                            range_arr[i][1] += OSM_QOS_POLICY_ULP_SDP_SERVICE_ID;
                        }

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2314 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 110:
#line 929 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "rds : sl" - default SL for RDS */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = range_arr[0][1] =
                           OSM_QOS_POLICY_ULP_RDS_SERVICE_ID + OSM_QOS_POLICY_ULP_RDS_PORT;

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = 1;

                    }
#line 2331 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 112:
#line 942 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* rds with port numbers */
                        uint64_t ** range_arr;
                        unsigned    range_len;
                        unsigned    i;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("RDS ULP rule doesn't have port numbers");
                            return 1;
                        }

                        /* get all the port ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );
                        /* now translate these port numbers into service ids */
                        for (i = 0; i < range_len; i++)
                        {
                            if (range_arr[i][0] > 0xFFFF || range_arr[i][1] > 0xFFFF)
                            {
                                yyerror("SDP port number out of range");
				free(range_arr);
                                return 1;
                            }
                            range_arr[i][0] += OSM_QOS_POLICY_ULP_RDS_SERVICE_ID;
                            range_arr[i][1] += OSM_QOS_POLICY_ULP_RDS_SERVICE_ID;
                        }

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2369 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 114:
#line 976 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "iSER : sl" - default SL for iSER */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = range_arr[0][1] =
                           OSM_QOS_POLICY_ULP_ISER_SERVICE_ID + OSM_QOS_POLICY_ULP_ISER_PORT;

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = 1;

                    }
#line 2386 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 116:
#line 989 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* iser with port numbers */
                        uint64_t ** range_arr;
                        unsigned    range_len;
                        unsigned    i;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("iSER ULP rule doesn't have port numbers");
                            return 1;
                        }

                        /* get all the port ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );
                        /* now translate these port numbers into service ids */
                        for (i = 0; i < range_len; i++)
                        {
                            if (range_arr[i][0] > 0xFFFF || range_arr[i][1] > 0xFFFF)
                            {
                                yyerror("SDP port number out of range");
				free(range_arr);
                                return 1;
                            }
                            range_arr[i][0] += OSM_QOS_POLICY_ULP_ISER_SERVICE_ID;
                            range_arr[i][1] += OSM_QOS_POLICY_ULP_ISER_SERVICE_ID;
                        }

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2424 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1023 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* srp with target guids - this rule is similar
                           to writing 'any' ulp with target port guids */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("SRP ULP rule doesn't have port guids");
                            return 1;
                        }

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_SRP_Targets_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the destination
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->destination_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

                    }
#line 2464 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1059 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* ipoib w/o any pkeys (default pkey) */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = range_arr[0][1] = 0x7fff;

                        /*
                         * Although we know that the default partition exists,
                         * we still need to validate it by checking that it has
                         * at least two full members. Otherwise IPoIB won't work.
                         */
                        if (__validate_pkeys(range_arr, 1, TRUE)) {
                            free(range_arr[0]);
                            free(range_arr);
                            return 1;
			}

                        p_current_qos_match_rule->pkey_range_arr = range_arr;
                        p_current_qos_match_rule->pkey_range_len = 1;

                    }
#line 2491 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1082 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* ipoib with pkeys */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("IPoIB ULP rule doesn't have pkeys");
                            return 1;
                        }

                        /* get all the pkey ranges */
                        __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        /*
                         * Validate pkeys.
                         * For IPoIB pkeys the validation is strict.
                         * If some problem would be found, parsing will
                         * be aborted with a proper error messages.
                         */
			if (__validate_pkeys(range_arr, range_len, TRUE)) {
			    free(range_arr);
                            return 1;
			}

                        p_current_qos_match_rule->pkey_range_arr = range_arr;
                        p_current_qos_match_rule->pkey_range_len = range_len;

                    }
#line 2527 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1116 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2533 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1119 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2539 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1122 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2545 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1125 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2551 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1128 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2557 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1131 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2563 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1134 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2569 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1137 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2575 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1140 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2581 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1143 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2587 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1146 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2593 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1149 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2599 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1152 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2605 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1155 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2611 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1158 "osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2617 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1161 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* get the SL for ULP rules */
                        cl_list_iterator_t  list_iterator;
                        uint64_t          * p_tmp_num;
                        uint8_t             sl;

                        list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                        p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
                        if (*p_tmp_num > 15)
                        {
                            yyerror("illegal SL value");
                            return 1;
                        }

                        sl = (uint8_t)(*p_tmp_num);
                        free(p_tmp_num);
                        cl_list_remove_all(&tmp_parser_struct.num_list);

                        p_current_qos_match_rule->p_qos_level =
                                 &osm_qos_policy_simple_qos_levels[sl];
                        p_current_qos_match_rule->qos_level_name =
                                 strdup(osm_qos_policy_simple_qos_levels[sl].name);

                        if (__parser_ulp_match_rule_end())
                            return 1;
                    }
#line 2648 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1200 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'name' of 'port-group' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_port_group->name)
                            {
                                yyerror("port-group has multiple 'name' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_port_group->name = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2674 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1223 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2682 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1228 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'use' of 'port-group' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_port_group->use)
                            {
                                yyerror("port-group has multiple 'use' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_port_group->use = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2708 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1251 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2716 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1256 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'port-name' in 'port-group' - any num of instances */
                            cl_list_iterator_t list_iterator;
                            osm_node_t * p_node;
                            osm_physp_t * p_physp;
                            unsigned port_num;
                            char * tmp_str;
                            char * port_str;

                            /* parsing port name strings */
                            for (list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                                 list_iterator != cl_list_end(&tmp_parser_struct.str_list);
                                 list_iterator = cl_list_next(list_iterator))
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                {
                                    /* last slash in port name string is a separator
                                       between node name and port number */
                                    port_str = strrchr(tmp_str, '/');
                                    if (!port_str || (strlen(port_str) < 3) ||
                                        (port_str[1] != 'p' && port_str[1] != 'P')) {
                                        yyerror("'%s' - illegal port name",
                                                           tmp_str);
                                        free(tmp_str);
                                        cl_list_remove_all(&tmp_parser_struct.str_list);
                                        return 1;
                                    }

                                    if (!(port_num = strtoul(&port_str[2],NULL,0))) {
                                        yyerror(
                                               "'%s' - illegal port number in port name",
                                               tmp_str);
                                        free(tmp_str);
                                        cl_list_remove_all(&tmp_parser_struct.str_list);
                                        return 1;
                                    }

                                    /* separate node name from port number */
                                    port_str[0] = '\0';

                                    if (st_lookup(p_qos_policy->p_node_hash,
                                                  (st_data_t)tmp_str,
                                                  (void *)&p_node))
                                    {
                                        /* we found the node, now get the right port */
                                        p_physp = osm_node_get_physp_ptr(p_node, port_num);
                                        if (!p_physp) {
                                            yyerror(
                                                   "'%s' - port number out of range in port name",
                                                   tmp_str);
                                            free(tmp_str);
                                            cl_list_remove_all(&tmp_parser_struct.str_list);
                                            return 1;
                                        }
                                        /* we found the port, now add it to guid table */
                                        __parser_add_port_to_port_map(&p_current_port_group->port_map,
                                                                      p_physp);
                                    }
                                    free(tmp_str);
                                }
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2785 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1322 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2793 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1327 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'port-guid' in 'port-group' - any num of instances */
                            /* list of guid ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                __parser_add_guid_range_to_port_map(
                                                      &p_current_port_group->port_map,
                                                      range_arr,
                                                      range_len);
                            }
                        }
#line 2816 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1347 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2824 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1352 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'prefix' in 'port-group' - any num of instances */
                            /* list of prefix ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list)) {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr(
				    &tmp_parser_struct.num_pair_list,
                                    &range_arr,
                                    &range_len);

                                __parser_add_prefix_range_to_prefix_map(
                                    &p_current_port_group->prefix_map,
                                    range_arr,
                                    range_len);
                            }
                        }
#line 2847 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1372 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2855 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1377 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'GID' in 'port-group' - any num of instances */
                            /* list of GID ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list)) {
                                ib_gid_t ** range_arr;
                                unsigned range_len;

                                __gidrangelist2rangearr(
				    &tmp_parser_struct.num_pair_list,
                                    &range_arr,
                                    &range_len);

				__parser_add_gid_range_to_gid_map(
                                    &p_current_port_group->prefix_map,
                                    range_arr,
                                    range_len);
                            }
                        }
#line 2878 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1397 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2886 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1403 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'pkey' in 'port-group' - any num of instances */
                            /* list of pkey ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                __parser_add_pkey_range_to_port_map(
                                                      &p_current_port_group->port_map,
                                                      range_arr,
                                                      range_len);
                            }
                        }
#line 2909 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1423 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2917 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1428 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'partition' in 'port-group' - any num of instances */
                            __parser_add_partition_list_to_port_map(
                                               &p_current_port_group->port_map,
                                               &tmp_parser_struct.str_list);
                        }
#line 2928 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1436 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2936 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1441 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'node-type' in 'port-group' - any num of instances */
                        }
#line 2944 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1446 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2952 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1462 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            p_current_port_group->node_types |=
                               OSM_QOS_POLICY_NODE_TYPE_CA;
                        }
#line 2961 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1468 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            p_current_port_group->node_types |=
                               OSM_QOS_POLICY_NODE_TYPE_SWITCH;
                        }
#line 2970 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1474 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            p_current_port_group->node_types |=
                               OSM_QOS_POLICY_NODE_TYPE_ROUTER;
                        }
#line 2979 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1480 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            p_current_port_group->node_types |=
                               (OSM_QOS_POLICY_NODE_TYPE_CA |
                                OSM_QOS_POLICY_NODE_TYPE_SWITCH |
                                OSM_QOS_POLICY_NODE_TYPE_ROUTER);
                        }
#line 2990 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1488 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            osm_port_t * p_osm_port =
                                osm_get_port_by_guid(p_qos_policy->p_subn,
                                     p_qos_policy->p_subn->sm_port_guid);
                            if (p_osm_port)
                                __parser_add_port_to_port_map(
                                   &p_current_port_group->port_map,
                                   p_osm_port->p_physp);
                        }
#line 3004 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1510 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'group' in 'vlarb-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_vlarb_scope->group_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3024 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1527 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3032 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1532 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'across' in 'vlarb-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_vlarb_scope->across_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3052 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1549 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3060 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1554 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'vl-high-limit' in 'vlarb-scope' - one instance of one number */
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * p_tmp_num;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
                            if (p_tmp_num)
                            {
                                p_current_vlarb_scope->vl_high_limit = (uint32_t)(*p_tmp_num);
                                p_current_vlarb_scope->vl_high_limit_set = TRUE;
                                free(p_tmp_num);
                            }

                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3081 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1572 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3089 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1577 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'vlarb-high' in 'vlarb-scope' - list of pairs of numbers with ':' and ',' */
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                    cl_list_insert_tail(&p_current_vlarb_scope->vlarb_high_list,num_pair);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3109 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1594 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3117 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1599 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'vlarb-low' in 'vlarb-scope' - list of pairs of numbers with ':' and ',' */
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                    cl_list_insert_tail(&p_current_vlarb_scope->vlarb_low_list,num_pair);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3137 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1616 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3145 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1632 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'group' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_sl2vl_scope->group_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3165 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1649 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3173 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1654 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'across' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str) {
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_from_list,tmp_str);
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_to_list,strdup(tmp_str));
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3195 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1673 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3203 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1678 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'across-from' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_from_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3223 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1695 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3231 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1700 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'across-to' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str) {
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_to_list,tmp_str);
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3252 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1718 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3260 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1723 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'from' in 'sl2vl-scope' - any num of instances */
                        }
#line 3268 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1728 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3276 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1733 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'to' in 'sl2vl-scope' - any num of instances */
                        }
#line 3284 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1738 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3292 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1747 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            int i;
                            for (i = 0; i < OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH; i++)
                                p_current_sl2vl_scope->from[i] = TRUE;
                        }
#line 3302 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1758 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            int i;
                            for (i = 0; i < OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH; i++)
                                p_current_sl2vl_scope->to[i] = TRUE;
                        }
#line 3312 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1765 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            int i;
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;
                            uint8_t               num1, num2;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                {
                                    if ( num_pair[1] >= OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH )
                                    {
                                        yyerror("port number out of range 'from' list");
                                        free(num_pair);
                                        cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                                        return 1;
                                    }
                                    num1 = (uint8_t)num_pair[0];
                                    num2 = (uint8_t)num_pair[1];
                                    free(num_pair);
                                    for (i = num1; i <= num2; i++)
                                        p_current_sl2vl_scope->from[i] = TRUE;
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3346 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1796 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            int i;
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;
                            uint8_t               num1, num2;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                {
                                    if ( num_pair[1] >= OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH )
                                    {
                                        yyerror("port number out of range 'to' list");
                                        free(num_pair);
                                        cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                                        return 1;
                                    }
                                    num1 = (uint8_t)num_pair[0];
                                    num2 = (uint8_t)num_pair[1];
                                    free(num_pair);
                                    for (i = num1; i <= num2; i++)
                                        p_current_sl2vl_scope->to[i] = TRUE;
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3380 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1828 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'sl2vl-table' - one instance of exactly
                               OSM_QOS_POLICY_SL2VL_TABLE_LEN numbers */
                            cl_list_iterator_t    list_iterator;
                            uint64_t              num;
                            uint64_t            * p_num;
                            int                   i = 0;

                            if (p_current_sl2vl_scope->sl2vl_table_set)
                            {
                                yyerror("sl2vl-scope has more than one sl2vl-table");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }

                            if (cl_list_count(&tmp_parser_struct.num_list) != OSM_QOS_POLICY_SL2VL_TABLE_LEN)
                            {
                                yyerror("wrong number of values in 'sl2vl-table' (should be 16)");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_list) )
                            {
                                p_num = (uint64_t*)cl_list_obj(list_iterator);
                                num = *p_num;
                                free(p_num);
                                if (num >= OSM_QOS_POLICY_MAX_VL_NUM)
                                {
                                    yyerror("wrong VL value in 'sl2vl-table' (should be 0 to 15)");
                                    cl_list_remove_all(&tmp_parser_struct.num_list);
                                    return 1;
                                }

                                p_current_sl2vl_scope->sl2vl_table[i++] = (uint8_t)num;
                                list_iterator = cl_list_next(list_iterator);
                            }
                            p_current_sl2vl_scope->sl2vl_table_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3426 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1871 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3434 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1888 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'name' of 'qos-level' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_qos_level->name)
                            {
                                yyerror("qos-level has multiple 'name' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_level->name = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3460 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1911 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3468 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1916 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'use' of 'qos-level' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_qos_level->use)
                            {
                                yyerror("qos-level has multiple 'use' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_level->use = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3494 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1939 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3502 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1944 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'sl' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->sl_set)
                            {
                                yyerror("'qos-level' has multiple 'sl' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            p_current_qos_level->sl = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->sl_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3525 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1964 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3533 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1969 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'mtu-limit' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->mtu_limit_set)
                            {
                                yyerror("'qos-level' has multiple 'mtu-limit' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            if (*p_num > OSM_QOS_POLICY_MAX_MTU || *p_num < OSM_QOS_POLICY_MIN_MTU)
                            {
                                yyerror("mtu limit is out of range, value: %d", *p_num);
                                free(p_num);
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            p_current_qos_level->mtu_limit = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->mtu_limit_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3563 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1996 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'mtu-limit' in 'qos-level' - one instance */
                            RESET_BUFFER;
                        }
#line 3572 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 210:
#line 2002 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'rate-limit' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->rate_limit_set)
                            {
                                yyerror("'qos-level' has multiple 'rate-limit' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            if (*p_num > OSM_QOS_POLICY_MAX_RATE || *p_num < OSM_QOS_POLICY_MIN_RATE)
                            {
                                yyerror("rate limit is out of range, value: %d", *p_num);
                                free(p_num);
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            p_current_qos_level->rate_limit = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->rate_limit_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3602 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 211:
#line 2029 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'rate-limit' in 'qos-level' - one instance */
                            RESET_BUFFER;
                        }
#line 3611 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 212:
#line 2035 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'packet-life' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->pkt_life_set)
                            {
                                yyerror("'qos-level' has multiple 'packet-life' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            p_current_qos_level->pkt_life = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->pkt_life_set= TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3634 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 213:
#line 2055 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'packet-life' in 'qos-level' - one instance */
                            RESET_BUFFER;
                        }
#line 3643 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 214:
#line 2061 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'path-bits' in 'qos-level' - any num of instances */
                            /* list of path bit ranges */

                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_level->path_bits_range_len )
                                {
                                    p_current_qos_level->path_bits_range_arr = range_arr;
                                    p_current_qos_level->path_bits_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_level->path_bits_range_arr,
                                                      p_current_qos_level->path_bits_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_level->path_bits_range_arr = new_range_arr;
                                    p_current_qos_level->path_bits_range_len = new_range_len;
                                }
                            }
                        }
#line 3681 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 215:
#line 2096 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3689 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 216:
#line 2101 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'pkey' in 'qos-level' - num of instances of list of ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_level->pkey_range_len )
                                {
                                    p_current_qos_level->pkey_range_arr = range_arr;
                                    p_current_qos_level->pkey_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_level->pkey_range_arr,
                                                      p_current_qos_level->pkey_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_level->pkey_range_arr = new_range_arr;
                                    p_current_qos_level->pkey_range_len = new_range_len;
                                }
                            }
                        }
#line 3725 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 217:
#line 2134 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3733 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 218:
#line 2151 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'use' of 'qos-match-rule' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_qos_match_rule->use)
                            {
                                yyerror("'qos-match-rule' has multiple 'use' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_match_rule->use = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3759 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 219:
#line 2174 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3767 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 220:
#line 2179 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'qos-class' in 'qos-match-rule' - num of instances of list of ranges */
                            /* list of class ranges (QoS Class is 12-bit value) */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_match_rule->qos_class_range_len )
                                {
                                    p_current_qos_match_rule->qos_class_range_arr = range_arr;
                                    p_current_qos_match_rule->qos_class_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_match_rule->qos_class_range_arr,
                                                      p_current_qos_match_rule->qos_class_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_match_rule->qos_class_range_arr = new_range_arr;
                                    p_current_qos_match_rule->qos_class_range_len = new_range_len;
                                }
                            }
                        }
#line 3804 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 221:
#line 2213 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3812 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 222:
#line 2218 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'source' in 'qos-match-rule' - text */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_qos_match_rule->source_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3832 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 223:
#line 2235 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3840 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 224:
#line 2240 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'destination' in 'qos-match-rule' - text */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_qos_match_rule->destination_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3860 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 225:
#line 2257 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3868 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 226:
#line 2262 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'qos-level-name' in 'qos-match-rule' - single string */
                            cl_list_iterator_t   list_iterator;
                            char               * tmp_str;

                            if (p_current_qos_match_rule->qos_level_name)
                            {
                                yyerror("qos-match-rule has multiple 'qos-level-name' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_match_rule->qos_level_name = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3894 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 227:
#line 2285 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3902 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 228:
#line 2290 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'service-id' in 'qos-match-rule' - num of instances of list of ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_match_rule->service_id_range_len )
                                {
                                    p_current_qos_match_rule->service_id_range_arr = range_arr;
                                    p_current_qos_match_rule->service_id_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_match_rule->service_id_range_arr,
                                                      p_current_qos_match_rule->service_id_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_match_rule->service_id_range_arr = new_range_arr;
                                    p_current_qos_match_rule->service_id_range_len = new_range_len;
                                }
                            }
                        }
#line 3938 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 229:
#line 2323 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3946 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 230:
#line 2328 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'pkey' in 'qos-match-rule' - num of instances of list of ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_match_rule->pkey_range_len )
                                {
                                    p_current_qos_match_rule->pkey_range_arr = range_arr;
                                    p_current_qos_match_rule->pkey_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_match_rule->pkey_range_arr,
                                                      p_current_qos_match_rule->pkey_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_match_rule->pkey_range_arr = new_range_arr;
                                    p_current_qos_match_rule->pkey_range_len = new_range_len;
                                }
                            }
                        }
#line 3982 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 231:
#line 2361 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3990 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 232:
#line 2372 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        cl_list_insert_tail(&tmp_parser_struct.str_list,
                                            strdup(__parser_strip_white(tmp_parser_struct.str)));
                        tmp_parser_struct.str[0] = '\0';
                    }
#line 4000 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 235:
#line 2383 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			size_t str_len = strlen(tmp_parser_struct.str);
			size_t addition_len = strlen((yyvsp[0]));
			if ((str_len + addition_len) <= OSM_QOS_POLICY_MAX_LINE_LEN)
	                        strcat(tmp_parser_struct.str,(yyvsp[0]));
                        free((yyvsp[0]));
			yylval = NULL;
                    }
#line 4013 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 241:
#line 2407 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        uint64_t * p_num = (uint64_t*)malloc(sizeof(uint64_t));
                        __parser_str2uint64(p_num,(yyvsp[0]));
                        free((yyvsp[0]));
			yylval = NULL;
                        cl_list_insert_tail(&tmp_parser_struct.num_list, p_num);
                    }
#line 4025 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 242:
#line 2416 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        num_pair[0] = tmp_parser_struct.num_pair[0];
                        num_pair[1] = tmp_parser_struct.num_pair[1];
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4036 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 243:
#line 2422 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        num_pair[0] = tmp_parser_struct.num_pair[0];
                        num_pair[1] = tmp_parser_struct.num_pair[1];
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4047 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 244:
#line 2430 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[0],(yyvsp[0]));
                        free((yyvsp[0]));
			yylval = NULL;
                    }
#line 4057 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 245:
#line 2437 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[1],(yyvsp[0]));
                        free((yyvsp[0]));
			yylval = NULL;
                    }
#line 4067 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 247:
#line 2447 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        num_pair[0] = tmp_parser_struct.num_pair[0];
                        num_pair[1] = tmp_parser_struct.num_pair[1];
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4078 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 248:
#line 2453 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        if (tmp_parser_struct.num_pair[0] <= tmp_parser_struct.num_pair[1]) {
                            num_pair[0] = tmp_parser_struct.num_pair[0];
                            num_pair[1] = tmp_parser_struct.num_pair[1];
                        }
                        else {
                            num_pair[1] = tmp_parser_struct.num_pair[0];
                            num_pair[0] = tmp_parser_struct.num_pair[1];
                        }
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4095 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 249:
#line 2465 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        if (tmp_parser_struct.num_pair[0] <= tmp_parser_struct.num_pair[1]) {
                            num_pair[0] = tmp_parser_struct.num_pair[0];
                            num_pair[1] = tmp_parser_struct.num_pair[1];
                        }
                        else {
                            num_pair[1] = tmp_parser_struct.num_pair[0];
                            num_pair[0] = tmp_parser_struct.num_pair[1];
                        }
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4112 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 250:
#line 2477 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
                        num_pair[0] = tmp_parser_struct.num_pair[0];
                        num_pair[1] = tmp_parser_struct.num_pair[1];
                        cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
                    }
#line 4123 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 251:
#line 2485 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[0],(yyvsp[0]));
                        __parser_str2uint64(&tmp_parser_struct.num_pair[1],(yyvsp[0]));
                        free((yyvsp[0]));
			yylval = NULL;
                    }
#line 4134 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 252:
#line 2493 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[0],(yyvsp[0]));
                        free((yyvsp[0]));
			yylval = NULL;
                    }
#line 4144 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 253:
#line 2500 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_str2uint64(&tmp_parser_struct.num_pair[1],(yyvsp[0]));
                        free((yyvsp[0]));
			yylval = NULL;
                    }
#line 4154 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 255:
#line 2510 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			ib_gid_t * gid_pair = (ib_gid_t *)malloc(sizeof(ib_gid_t)*2);
			gid_pair[0] = tmp_parser_struct.gid_pair[0];
			gid_pair[1] = tmp_parser_struct.gid_pair[1];
			cl_list_insert_tail(&tmp_parser_struct.num_pair_list, gid_pair);
		    }
#line 4165 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 256:
#line 2516 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			ib_gid_t * gid_pair = (ib_gid_t *)malloc(sizeof(ib_gid_t)*2);
			if (__cmp_gids(tmp_parser_struct.gid_pair[0],
				       tmp_parser_struct.gid_pair[1]) < 1) {
			    gid_pair[0] = tmp_parser_struct.gid_pair[0];
			    gid_pair[1] = tmp_parser_struct.gid_pair[1];
			}
			else {
			    gid_pair[1] = tmp_parser_struct.gid_pair[0];
			    gid_pair[0] = tmp_parser_struct.gid_pair[1];
			}
			cl_list_insert_tail(&tmp_parser_struct.num_pair_list, gid_pair);
		    }
#line 4183 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 257:
#line 2529 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			ib_gid_t * gid_pair = (ib_gid_t *)malloc(sizeof(ib_gid_t)*2);
			if (__cmp_gids(tmp_parser_struct.gid_pair[0],
				       tmp_parser_struct.gid_pair[1]) < 1) {
			    gid_pair[0] = tmp_parser_struct.gid_pair[0];
			    gid_pair[1] = tmp_parser_struct.gid_pair[1];
			}
			else {
			    gid_pair[1] = tmp_parser_struct.gid_pair[0];
			    gid_pair[0] = tmp_parser_struct.gid_pair[1];
			}
			cl_list_insert_tail(&tmp_parser_struct.num_pair_list, gid_pair);
		    }
#line 4201 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 258:
#line 2542 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			ib_gid_t * gid_pair = (ib_gid_t *)malloc(sizeof(ib_gid_t)*2);
			gid_pair[0] = tmp_parser_struct.gid_pair[0];
			gid_pair[1] = tmp_parser_struct.gid_pair[1];
			cl_list_insert_tail(&tmp_parser_struct.num_pair_list, gid_pair);
		    }
#line 4212 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 259:
#line 2550 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			__parser_str2gid(&tmp_parser_struct.gid_pair[0],(yyvsp[0]));
			__parser_str2gid(&tmp_parser_struct.gid_pair[1],(yyvsp[0]));
			free((yyvsp[0]));
			yylval = NULL;
		    }
#line 4223 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 260:
#line 2558 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			__parser_str2gid(&tmp_parser_struct.gid_pair[0],(yyvsp[0]));
			free((yyvsp[0]));
			yylval = NULL;
		    }
#line 4233 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 261:
#line 2565 "osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			__parser_str2gid(&tmp_parser_struct.gid_pair[1],(yyvsp[0]));
			free((yyvsp[0]));
			yylval = NULL;
		    }
#line 4243 "osm_qos_parser_y.c" /* yacc.c:1646  */
    break;


#line 4247 "osm_qos_parser_y.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2571 "osm_qos_parser_y.y" /* yacc.c:1906  */


/***************************************************
 ***************************************************/

int osm_qos_parse_policy_file(IN osm_subn_t * p_subn)
{
    int res = 0;
    static boolean_t first_time = TRUE;
    p_qos_parser_osm_log = &p_subn->p_osm->log;

    OSM_LOG_ENTER(p_qos_parser_osm_log);

    osm_qos_policy_destroy(p_subn->p_qos_policy);
    p_subn->p_qos_policy = NULL;

    if (!p_subn->opt.qos_policy_file) {
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_VERBOSE,
                "QoS policy file not specified\n");
        res = 1;
        goto Exit;
    }

    yyin = fopen (p_subn->opt.qos_policy_file, "r");
    if (!yyin)
    {
        if (strcmp(p_subn->opt.qos_policy_file,OSM_DEFAULT_QOS_POLICY_FILE)) {
            OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC01: "
                    "Failed opening QoS policy file %s - %s\n",
                    p_subn->opt.qos_policy_file, strerror(errno));
            res = 1;
        }
        else
            OSM_LOG(p_qos_parser_osm_log, OSM_LOG_VERBOSE,
                    "QoS policy file not found (%s)\n",
                    p_subn->opt.qos_policy_file);

        goto Exit;
    }

    if (first_time)
    {
        first_time = FALSE;
        __setup_simple_qos_levels();
        __setup_ulp_match_rules();
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_INFO,
		"Loading QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
    }
    else
        /*
         * ULP match rules list was emptied at the end of
         * previous parsing iteration.
         * What's left is to clear simple QoS levels.
         */
        __clear_simple_qos_levels();

    column_num = 1;
    line_num = 1;

    p_subn->p_qos_policy = osm_qos_policy_create(p_subn);

    __parser_tmp_struct_init();
    p_qos_policy = p_subn->p_qos_policy;

    res = yyparse();

    __parser_tmp_struct_destroy();

    if (res != 0)
    {
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC03: "
                "Failed parsing QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
        osm_qos_policy_destroy(p_subn->p_qos_policy);
        p_subn->p_qos_policy = NULL;
	if (yylval && strlen(yylval))
		free(yylval);
        osm_qos_policy_port_group_destroy(p_current_port_group);
        res = 1;
        goto Exit;
    }

    /* add generated ULP match rules to the usual match rules */
    __process_ulp_match_rules();

    if (osm_qos_policy_validate(p_subn->p_qos_policy,p_qos_parser_osm_log))
    {
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC04: "
                "Error(s) in QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
        fprintf(stderr, "Error(s) in QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
        osm_qos_policy_destroy(p_subn->p_qos_policy);
        p_subn->p_qos_policy = NULL;
        res = 1;
        goto Exit;
    }

  Exit:
    if (yyin)
    {
        yyrestart(yyin);
        fclose(yyin);
    }
    OSM_LOG_EXIT(p_qos_parser_osm_log);
    return res;
}

/***************************************************
 ***************************************************/

int yywrap()
{
    return(1);
}

/***************************************************
 ***************************************************/

static void yyerror(const char *format, ...)
{
    char s[256];
    va_list pvar;

    OSM_LOG_ENTER(p_qos_parser_osm_log);

    va_start(pvar, format);
    vsnprintf(s, sizeof(s), format, pvar);
    va_end(pvar);

    OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC05: "
            "Syntax error (line %d:%d): %s\n",
            line_num, column_num, s);
    fprintf(stderr, "Error in QoS Policy File (line %d:%d): %s.\n",
            line_num, column_num, s);
    OSM_LOG_EXIT(p_qos_parser_osm_log);
}

/***************************************************
 ***************************************************/

static char * __parser_strip_white(char * str)
{
	char *p;

	while (isspace(*str))
		str++;
	if (!*str)
		return str;
	p = str + strlen(str) - 1;
	while (isspace(*p))
		*p-- = '\0';

	return str;
}

/***************************************************
 ***************************************************/

static void __parser_str2uint64(uint64_t * p_val, char * str)
{
   *p_val = strtoull(str, NULL, 0);
}

/***************************************************
 ***************************************************/

static void __parser_port_group_start()
{
    p_current_port_group = osm_qos_policy_port_group_create();
}

/***************************************************
 ***************************************************/

static int __parser_port_group_end()
{
    if(!p_current_port_group->name)
    {
        yyerror("port-group validation failed - no port group name specified");
        return -1;
    }

    if (p_current_port_group) {
	cl_list_insert_tail(&p_qos_policy->port_groups,
	                    p_current_port_group);
	p_current_port_group = NULL;
    }

    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_vlarb_scope_start()
{
    p_current_vlarb_scope = osm_qos_policy_vlarb_scope_create();
}

/***************************************************
 ***************************************************/

static int __parser_vlarb_scope_end()
{
    if ( !cl_list_count(&p_current_vlarb_scope->group_list) &&
         !cl_list_count(&p_current_vlarb_scope->across_list) )
    {
        yyerror("vlarb-scope validation failed - no port groups specified by 'group' or by 'across'");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->vlarb_tables,
                        p_current_vlarb_scope);
    p_current_vlarb_scope = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_sl2vl_scope_start()
{
    p_current_sl2vl_scope = osm_qos_policy_sl2vl_scope_create();
}

/***************************************************
 ***************************************************/

static int __parser_sl2vl_scope_end()
{
    if (!p_current_sl2vl_scope->sl2vl_table_set)
    {
        yyerror("sl2vl-scope validation failed - no sl2vl table specified");
        return -1;
    }
    if ( !cl_list_count(&p_current_sl2vl_scope->group_list) &&
         !cl_list_count(&p_current_sl2vl_scope->across_to_list) &&
         !cl_list_count(&p_current_sl2vl_scope->across_from_list) )
    {
        yyerror("sl2vl-scope validation failed - no port groups specified by 'group', 'across-to' or 'across-from'");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->sl2vl_tables,
                        p_current_sl2vl_scope);
    p_current_sl2vl_scope = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_qos_level_start()
{
    p_current_qos_level = osm_qos_policy_qos_level_create();
}

/***************************************************
 ***************************************************/

static int __parser_qos_level_end()
{
    if (!p_current_qos_level->sl_set)
    {
        yyerror("qos-level validation failed - no 'sl' specified");
        return -1;
    }
    if (!p_current_qos_level->name)
    {
        yyerror("qos-level validation failed - no 'name' specified");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->qos_levels,
                        p_current_qos_level);
    p_current_qos_level = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_match_rule_start()
{
    p_current_qos_match_rule = osm_qos_policy_match_rule_create();
}

/***************************************************
 ***************************************************/

static int __parser_match_rule_end()
{
    if (!p_current_qos_match_rule->qos_level_name)
    {
        yyerror("match-rule validation failed - no 'qos-level-name' specified");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->qos_match_rules,
                        p_current_qos_match_rule);
    p_current_qos_match_rule = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_ulp_match_rule_start()
{
    p_current_qos_match_rule = osm_qos_policy_match_rule_create();
}

/***************************************************
 ***************************************************/

static int __parser_ulp_match_rule_end()
{
    OSM_ASSERT(p_current_qos_match_rule->p_qos_level);
    cl_list_insert_tail(&__ulp_match_rules,
                        p_current_qos_match_rule);
    p_current_qos_match_rule = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

/* Address copied to p_val in network order. */
static void __parser_str2gid(ib_gid_t * p_val, char * str)
{
    inet_pton(AF_INET6, str, p_val);
}

/***************************************************
 ***************************************************/

static void __parser_tmp_struct_init()
{
    tmp_parser_struct.str[0] = '\0';
    cl_list_construct(&tmp_parser_struct.str_list);
    cl_list_init(&tmp_parser_struct.str_list, 10);
    cl_list_construct(&tmp_parser_struct.num_list);
    cl_list_init(&tmp_parser_struct.num_list, 10);
    cl_list_construct(&tmp_parser_struct.num_pair_list);
    cl_list_init(&tmp_parser_struct.num_pair_list, 10);
}

/***************************************************
 ***************************************************/

/*
 * Do NOT free objects from the temp struct.
 * Either they are inserted into the parse tree data
 * structure, or they are already freed when copying
 * their values to the parse tree data structure.
 */
static void __parser_tmp_struct_reset()
{
    tmp_parser_struct.str[0] = '\0';
    cl_list_remove_all(&tmp_parser_struct.str_list);
    cl_list_remove_all(&tmp_parser_struct.num_list);
    cl_list_remove_all(&tmp_parser_struct.num_pair_list);
}

/***************************************************
 ***************************************************/

static void __parser_tmp_struct_destroy()
{
    __parser_tmp_struct_reset();
    cl_list_destroy(&tmp_parser_struct.str_list);
    cl_list_destroy(&tmp_parser_struct.num_list);
    cl_list_destroy(&tmp_parser_struct.num_pair_list);
}

/***************************************************
 ***************************************************/

#define __SIMPLE_QOS_LEVEL_NAME "SimpleQoSLevel_SL"
#define __SIMPLE_QOS_LEVEL_DEFAULT_NAME "SimpleQoSLevel_DEFAULT"

static void __setup_simple_qos_levels()
{
    uint8_t i;
    char tmp_buf[30];
    memset(osm_qos_policy_simple_qos_levels, 0,
           sizeof(osm_qos_policy_simple_qos_levels));
    for (i = 0; i < 16; i++)
    {
        osm_qos_policy_simple_qos_levels[i].sl = i;
        osm_qos_policy_simple_qos_levels[i].sl_set = TRUE;
        sprintf(tmp_buf, "%s%u", __SIMPLE_QOS_LEVEL_NAME, i);
        osm_qos_policy_simple_qos_levels[i].name = strdup(tmp_buf);
    }

    memset(&__default_simple_qos_level, 0,
           sizeof(__default_simple_qos_level));
    __default_simple_qos_level.name =
           strdup(__SIMPLE_QOS_LEVEL_DEFAULT_NAME);
}

/***************************************************
 ***************************************************/

static void __clear_simple_qos_levels()
{
    /*
     * Simple QoS levels are static.
     * What's left is to invalidate default simple QoS level.
     */
    __default_simple_qos_level.sl_set = FALSE;
}

/***************************************************
 ***************************************************/

static void __setup_ulp_match_rules()
{
    cl_list_construct(&__ulp_match_rules);
    cl_list_init(&__ulp_match_rules, 10);
}

/***************************************************
 ***************************************************/

static void __process_ulp_match_rules()
{
    cl_list_iterator_t list_iterator;
    osm_qos_match_rule_t *p_qos_match_rule = NULL;

    list_iterator = cl_list_head(&__ulp_match_rules);
    while (list_iterator != cl_list_end(&__ulp_match_rules))
    {
        p_qos_match_rule = (osm_qos_match_rule_t *) cl_list_obj(list_iterator);
        if (p_qos_match_rule)
            cl_list_insert_tail(&p_qos_policy->qos_match_rules,
                                p_qos_match_rule);
        list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(&__ulp_match_rules);
}

/***************************************************
 ***************************************************/

static int __cmp_num_range(const void * p1, const void * p2)
{
    uint64_t * pair1 = *((uint64_t **)p1);
    uint64_t * pair2 = *((uint64_t **)p2);

    if (pair1[0] < pair2[0])
        return -1;
    if (pair1[0] > pair2[0])
        return 1;

    if (pair1[1] < pair2[1])
        return -1;
    if (pair1[1] > pair2[1])
        return 1;

    return 0;
}

/***************************************************
 ***************************************************/

static void __sort_reduce_rangearr(
    uint64_t  **   arr,
    unsigned       arr_len,
    uint64_t  ** * p_res_arr,
    unsigned     * p_res_arr_len )
{
    unsigned i = 0;
    unsigned j = 0;
    unsigned last_valid_ind = 0;
    unsigned valid_cnt = 0;
    uint64_t ** res_arr;
    boolean_t * is_valid_arr;

    *p_res_arr = NULL;
    *p_res_arr_len = 0;

    qsort(arr, arr_len, sizeof(uint64_t*), __cmp_num_range);

    is_valid_arr = (boolean_t *)malloc(arr_len * sizeof(boolean_t));
    is_valid_arr[last_valid_ind] = TRUE;
    valid_cnt++;
    for (i = 1; i < arr_len; i++)
    {
        if (arr[i][0] <= arr[last_valid_ind][1])
        {
            if (arr[i][1] > arr[last_valid_ind][1])
                arr[last_valid_ind][1] = arr[i][1];
            free(arr[i]);
            arr[i] = NULL;
            is_valid_arr[i] = FALSE;
        }
        else if ((arr[i][0] - 1) == arr[last_valid_ind][1])
        {
            arr[last_valid_ind][1] = arr[i][1];
            free(arr[i]);
            arr[i] = NULL;
            is_valid_arr[i] = FALSE;
        }
        else
        {
            is_valid_arr[i] = TRUE;
            last_valid_ind = i;
            valid_cnt++;
        }
    }

    res_arr = (uint64_t **)malloc(valid_cnt * sizeof(uint64_t *));
    for (i = 0; i < arr_len; i++)
    {
        if (is_valid_arr[i])
            res_arr[j++] = arr[i];
    }
    free(is_valid_arr);
    free(arr);

    *p_res_arr = res_arr;
    *p_res_arr_len = valid_cnt;
}

/***************************************************
 ***************************************************/

inline static int __cmp_gids(ib_gid_t gid1, ib_gid_t gid2)
{
    uint64_t prefix1 = cl_ntoh64(gid1.unicast.prefix),
        prefix2 = cl_ntoh64(gid2.unicast.prefix),
        guid1 = cl_ntoh64(gid1.unicast.interface_id),
        guid2 = cl_ntoh64(gid2.unicast.interface_id);

    if (prefix1 < prefix2)
        return -1;
    if (prefix1 > prefix2)
        return 1;
    if (guid1 < guid2)
        return -1;
    if (guid1 > guid2)
        return 1;

    return 0;
}

/***************************************************
 ***************************************************/

static int __cmp_gid_range(const void * p1, const void * p2)
{
    ib_gid_t * pair1 = *((ib_gid_t **)p1);
    ib_gid_t * pair2 = *((ib_gid_t **)p2);
    int cmp;

    cmp = __cmp_gids(pair1[0], pair2[0]);
    return cmp ? cmp : __cmp_gids(pair1[1], pair2[1]);
}

/***************************************************
 ***************************************************/

static void __sort_reduce_gidrangearr(
    ib_gid_t  **   arr,
    unsigned       arr_len,
    ib_gid_t  ** * p_res_arr,
    unsigned     * p_res_arr_len)
{
    unsigned i = 0;
    unsigned j = 0;
    unsigned last_valid_ind = 0;
    unsigned valid_cnt = 0;
    ib_gid_t ** res_arr;
    boolean_t * is_valid_arr;
    ib_gid_t prev_gid;

    *p_res_arr = NULL;
    *p_res_arr_len = 0;

    /* Sort pairs by 1st elements, or by 2nd element if 1st are equal */
    qsort(arr, arr_len, sizeof(ib_gid_t*), __cmp_gid_range);

    is_valid_arr = (boolean_t *)malloc(arr_len * sizeof(boolean_t));
    is_valid_arr[last_valid_ind] = TRUE;
    valid_cnt++;
    for (i = 1; i < arr_len; i++) {
        /* 1st range: arr[last_valid_ind], 2nd range: arr[i] */
        if (__cmp_gids(arr[i][0], arr[last_valid_ind][1]) < 1) {
            /* 2nd range start is within 1st range */
            if (__cmp_gids(arr[i][1], arr[last_valid_ind][1]) == 1) {
                /* 2nd range end is also within 1st range */
                arr[last_valid_ind][1] = arr[i][1];
            }
            free(arr[i]);
            arr[i] = NULL;
            is_valid_arr[i] = FALSE;
        } else {
            prev_gid.unicast.prefix = arr[i][0].unicast.prefix;
            prev_gid.unicast.interface_id =
                cl_hton64(cl_ntoh64(arr[i][0].unicast.interface_id) - 1);
            if (!__cmp_gids(prev_gid, arr[last_valid_ind][1])) {
                /* ranges are continuous */
                arr[last_valid_ind][1] = arr[i][1];
                free(arr[i]);
                arr[i] = NULL;
                is_valid_arr[i] = FALSE;
            } else {
                is_valid_arr[i] = TRUE;
                last_valid_ind = i;
                valid_cnt++;
            }
        }
    }

    /* Return a fixed array contains the valid values, sorted */
    res_arr = (ib_gid_t **)malloc(valid_cnt * sizeof(ib_gid_t *));
    for (i = 0; i < arr_len; i++) {
        if (is_valid_arr[i])
            res_arr[j++] = arr[i];
    }
    free(is_valid_arr);
    free(arr);

    *p_res_arr = res_arr;
    *p_res_arr_len = valid_cnt;
}

/***************************************************
 ***************************************************/
static void __pkey_rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len)
{
    uint64_t   tmp_pkey;
    uint64_t * p_pkeys;
    cl_list_iterator_t list_iterator;

    list_iterator= cl_list_head(p_list);
    while( list_iterator != cl_list_end(p_list) )
    {
       p_pkeys = (uint64_t *)cl_list_obj(list_iterator);
       p_pkeys[0] &= 0x7fff;
       p_pkeys[1] &= 0x7fff;
       if (p_pkeys[0] > p_pkeys[1])
       {
           tmp_pkey = p_pkeys[1];
           p_pkeys[1] = p_pkeys[0];
           p_pkeys[0] = tmp_pkey;
       }
       list_iterator = cl_list_next(list_iterator);
    }

    __rangelist2rangearr(p_list, p_arr, p_arr_len);
}

/***************************************************
 ***************************************************/

static void __rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len)
{
    cl_list_iterator_t list_iterator;
    unsigned len = cl_list_count(p_list);
    unsigned i = 0;
    uint64_t ** tmp_arr;
    uint64_t ** res_arr = NULL;
    unsigned res_arr_len = 0;

    tmp_arr = (uint64_t **)malloc(len * sizeof(uint64_t *));

    list_iterator = cl_list_head(p_list);
    while( list_iterator != cl_list_end(p_list) )
    {
       tmp_arr[i++] = (uint64_t *)cl_list_obj(list_iterator);
       list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(p_list);

    __sort_reduce_rangearr( tmp_arr,
                            len,
                            &res_arr,
                            &res_arr_len );
    *p_arr = res_arr;
    *p_arr_len = res_arr_len;
}

/***************************************************
 ***************************************************/

static void __gidrangelist2rangearr(
    cl_list_t    * p_list,
    ib_gid_t  ** * p_arr,
    unsigned     * p_arr_len)
{
    cl_list_iterator_t list_iterator;
    unsigned len = cl_list_count(p_list);
    unsigned i = 0;
    ib_gid_t **tmp_arr;
    ib_gid_t **res_arr = NULL;
    unsigned res_arr_len = 0;

    tmp_arr = (ib_gid_t **)malloc(len * sizeof(ib_gid_t *));

    list_iterator = cl_list_head(p_list);
    while (list_iterator != cl_list_end(p_list)) {
        tmp_arr[i++] = (ib_gid_t *)cl_list_obj(list_iterator);
        list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(p_list);

    __sort_reduce_gidrangearr(tmp_arr,
                              len,
                              &res_arr,
                              &res_arr_len);
    *p_arr = res_arr;
    *p_arr_len = res_arr_len;
}
/***************************************************
 ***************************************************/

static void __merge_rangearr(
    uint64_t  **   range_arr_1,
    unsigned       range_len_1,
    uint64_t  **   range_arr_2,
    unsigned       range_len_2,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len )
{
    unsigned i = 0;
    unsigned j = 0;
    unsigned len = range_len_1 + range_len_2;
    uint64_t ** tmp_arr;
    uint64_t ** res_arr = NULL;
    unsigned res_arr_len = 0;

    *p_arr = NULL;
    *p_arr_len = 0;

    tmp_arr = (uint64_t **)malloc(len * sizeof(uint64_t *));

    for (i = 0; i < range_len_1; i++)
       tmp_arr[j++] = range_arr_1[i];
    for (i = 0; i < range_len_2; i++)
       tmp_arr[j++] = range_arr_2[i];
    free(range_arr_1);
    free(range_arr_2);

    __sort_reduce_rangearr( tmp_arr,
                            len,
                            &res_arr,
                            &res_arr_len );
    *p_arr = res_arr;
    *p_arr_len = res_arr_len;
}

/***************************************************
 ***************************************************/

static void __parser_add_port_to_port_map(
    cl_qmap_t   * p_map,
    osm_physp_t * p_physp)
{
    if (cl_qmap_get(p_map, cl_ntoh64(osm_physp_get_port_guid(p_physp))) ==
        cl_qmap_end(p_map))
    {
        osm_qos_port_t * p_port = osm_qos_policy_port_create(p_physp);
        if (p_port)
            cl_qmap_insert(p_map,
                           cl_ntoh64(osm_physp_get_port_guid(p_physp)),
                           &p_port->map_item);
    }
}

/***************************************************
 ***************************************************/

static void __parser_add_guid_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len)
{
    unsigned i;
    uint64_t guid_ho;
    osm_port_t * p_osm_port;

    if (!range_arr || !range_len)
        return;

    for (i = 0; i < range_len; i++) {
         for (guid_ho = range_arr[i][0]; guid_ho <= range_arr[i][1]; guid_ho++) {
             p_osm_port =
                osm_get_port_by_guid(p_qos_policy->p_subn, cl_hton64(guid_ho));
             if (p_osm_port)
                 __parser_add_port_to_port_map(p_map, p_osm_port->p_physp);
         }
         free(range_arr[i]);
    }
    free(range_arr);
}

/***************************************************
 ***************************************************/

static void __parser_add_prefix_range_to_prefix_map(
    cl_qmap_t * p_map,
    uint64_t ** range_arr,
    unsigned range_len)
{
    unsigned i;
    uint64_t prefix;
    osm_qos_subnet_ports_t *p_item_prefix;

    if (!range_arr || !range_len)
	return;

    for (i = 0; i < range_len; i++) {
	for (prefix = range_arr[i][0]; prefix <= range_arr[i][1]; prefix++) {
		/* check if prefix map already exist */
		p_item_prefix = (osm_qos_subnet_ports_t *)cl_qmap_get(p_map, prefix);

		/* If there is no map for this prefix, create one */
		if ((cl_map_item_t *)p_item_prefix == cl_qmap_end(p_map)) {
		    p_item_prefix =
			 (osm_qos_subnet_ports_t *)calloc(1, sizeof(osm_qos_subnet_ports_t));
		    if (!p_item_prefix) {
			OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC0A: "
				"Could not allocate memory for prefix in port group\n");
			continue;
		    }

		    cl_qmap_init((cl_qmap_t *)p_item_prefix);
		    cl_qmap_init(&p_item_prefix->guid_map);

		    cl_qmap_insert(p_map, prefix, (cl_map_item_t *)p_item_prefix);
		} else if (cl_qmap_count(&p_item_prefix->guid_map)) {
			/*
			 * If prefix exists, empty the guid map, because all the
			 * subnet should be in group
			 */
			osm_qos_remove_items(&p_item_prefix->guid_map, FALSE);
		}
	}
	free(range_arr[i]);
    }
    free(range_arr);
}

/***************************************************
 ***************************************************/

static void __parser_insert_guid_range(
    cl_qmap_t * p_map,
    ib_gid_t gid1,
    ib_gid_t gid2)
{
    cl_map_item_t *p_map_item;
    uint64_t cur_guid,
	guid1 = cl_ntoh64(gid1.unicast.interface_id),
	guid2 = cl_ntoh64(gid2.unicast.interface_id);

    for (cur_guid = guid1; cur_guid <= guid2; cur_guid++) {
	p_map_item = (cl_map_item_t *)calloc(1, sizeof(cl_map_item_t));
	if (!p_map_item) {
		OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC08: "
			"Could not allocate memory for guid in port group\n");
		continue;
	}

	cl_qmap_insert(p_map, cur_guid, p_map_item);
    }

}

static void __parser_add_gid_range_to_gid_map(
    cl_qmap_t * p_map,
    ib_gid_t ** p_arr,
    unsigned range_len)
{
    uint64_t prefix;
    osm_qos_subnet_ports_t *p_item_prefix = NULL;
    uint64_t prev_prefix = 0;
    int i = 0;
    boolean_t new_prefix = FALSE;

    for (i = 0; i < range_len; i++) {
	prefix = cl_ntoh64((p_arr[i][0]).unicast.prefix);

	/* check if prefix map is already held from previous gid range */
	if (prev_prefix != prefix || !p_item_prefix)
	    p_item_prefix = (osm_qos_subnet_ports_t *)cl_qmap_get(p_map, prefix);
	prev_prefix = prefix;

	/* If there is no map for this prefix, create one */
	if ((cl_map_item_t *)p_item_prefix == cl_qmap_end(p_map)) {
	    p_item_prefix =
	        (osm_qos_subnet_ports_t *)calloc(1, sizeof(osm_qos_subnet_ports_t));
	    if (!p_item_prefix) {
		OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC09: "
			"Could not allocate memory for guid in port group\n");
		continue;
	    }
	    new_prefix = TRUE;

	    cl_qmap_init((cl_qmap_t *)p_item_prefix);
	    cl_qmap_init(&p_item_prefix->guid_map);

	    cl_qmap_insert(p_map, prefix, (cl_map_item_t *)p_item_prefix);
	}

	/*
	 * In case GUID map is empty and prefix already existed - whole subnet
	 * of prefix is a part of the port group, no need to add GUID.
	 */
	if (cl_qmap_count(&p_item_prefix->guid_map) != 0 || new_prefix) {
	    __parser_insert_guid_range(&p_item_prefix->guid_map,
				       p_arr[i][0], p_arr[i][1]);
	}
	new_prefix = FALSE;
	free(p_arr[i]);
    }
    free(p_arr);
}

/***************************************************
 ***************************************************/

static void __parser_add_pkey_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len)
{
    unsigned i;
    uint64_t pkey_64;
    ib_net16_t pkey;
    osm_prtn_t * p_prtn;

    if (!range_arr || !range_len)
        return;

    for (i = 0; i < range_len; i++) {
         for (pkey_64 = range_arr[i][0]; pkey_64 <= range_arr[i][1]; pkey_64++) {
             pkey = cl_hton16((uint16_t)(pkey_64 & 0x7fff));
             p_prtn = (osm_prtn_t *)
                 cl_qmap_get(&p_qos_policy->p_subn->prtn_pkey_tbl, pkey);
             if (p_prtn != (osm_prtn_t *)cl_qmap_end(
                   &p_qos_policy->p_subn->prtn_pkey_tbl)) {
                 __parser_add_map_to_port_map(p_map, &p_prtn->part_guid_tbl);
                 __parser_add_map_to_port_map(p_map, &p_prtn->full_guid_tbl);
             }
         }
         free(range_arr[i]);
    }
    free(range_arr);
}

/***************************************************
 ***************************************************/

static void __parser_add_partition_list_to_port_map(
    cl_qmap_t  * p_map,
    cl_list_t  * p_list)
{
    cl_list_iterator_t    list_iterator;
    char                * tmp_str;
    osm_prtn_t          * p_prtn;

    /* extract all the ports from the partition
       to the port map of this port group */
    list_iterator = cl_list_head(p_list);
    while(list_iterator != cl_list_end(p_list)) {
        tmp_str = (char*)cl_list_obj(list_iterator);
        if (tmp_str) {
            p_prtn = osm_prtn_find_by_name(p_qos_policy->p_subn, tmp_str);
            if (p_prtn) {
                __parser_add_map_to_port_map(p_map, &p_prtn->part_guid_tbl);
                __parser_add_map_to_port_map(p_map, &p_prtn->full_guid_tbl);
            }
            free(tmp_str);
        }
        list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(p_list);
}

/***************************************************
 ***************************************************/

static void __parser_add_map_to_port_map(
    cl_qmap_t * p_dmap,
    cl_map_t  * p_smap)
{
    cl_map_iterator_t map_iterator;
    osm_physp_t * p_physp;

    if (!p_dmap || !p_smap)
        return;

    map_iterator = cl_map_head(p_smap);
    while (map_iterator != cl_map_end(p_smap)) {
        p_physp = (osm_physp_t*)cl_map_obj(map_iterator);
        __parser_add_port_to_port_map(p_dmap, p_physp);
        map_iterator = cl_map_next(map_iterator);
    }
}

/***************************************************
 ***************************************************/

static int __validate_pkeys( uint64_t ** range_arr,
                             unsigned    range_len,
                             boolean_t   is_ipoib)
{
    unsigned i;
    uint64_t pkey_64;
    ib_net16_t pkey;
    osm_prtn_t * p_prtn;

    if (!range_arr || !range_len)
        return 0;

    for (i = 0; i < range_len; i++) {
        for (pkey_64 = range_arr[i][0]; pkey_64 <= range_arr[i][1]; pkey_64++) {
            pkey = cl_hton16((uint16_t)(pkey_64 & 0x7fff));
            p_prtn = (osm_prtn_t *)
                cl_qmap_get(&p_qos_policy->p_subn->prtn_pkey_tbl, pkey);

            if (p_prtn == (osm_prtn_t *)cl_qmap_end(
                  &p_qos_policy->p_subn->prtn_pkey_tbl))
                p_prtn = NULL;

            if (is_ipoib) {
                /*
                 * Be very strict for IPoIB partition:
                 *  - the partition for the pkey have to exist
                 *  - it has to have at least 2 full members
                 */
                if (!p_prtn) {
                    yyerror("IPoIB partition, pkey 0x%04X - "
                                       "partition doesn't exist",
                                       cl_ntoh16(pkey));
                    return 1;
                }
                else if (cl_map_count(&p_prtn->full_guid_tbl) < 2) {
                    yyerror("IPoIB partition, pkey 0x%04X - "
                                       "partition has less than two full members",
                                       cl_ntoh16(pkey));
                    return 1;
                }
            }
            else if (!p_prtn) {
                /*
                 * For non-IPoIB pkey we just want to check that
                 * the relevant partition exists.
                 * And even if it doesn't, don't exit - just print
                 * error message and continue.
                 */
                 OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC02: "
			 "pkey 0x%04X - partition doesn't exist",
                         cl_ntoh16(pkey));
            }
        }
    }
    return 0;
}

/***************************************************
 ***************************************************/
